' COMAL - COM Access Library. COMAL (Pronounced COM UL).
'
' comaldb.dll is a Dynamic Linked Library written by me, John White,
' for myself and any programming language that can utilize it.
'
' Website: http://www.yoingco.com/
'   Email: john@yoingco.com
'
' Tested On: Windows XP Pro - XP SP2 with all updates as of 30th January 2005.
'               Office 2003 - SP1 with all updates as of 30th January 2005.
'                  Computer - DELL Optiplex GX110, Intel Pentium 3 (600Mhz) with 384Mb Memory.
'
' ComalDB was originally tested on Office XP 2002 but is now being tested on Office 2003.
'
' This demo needs the PersonalDetails.mdb file in the same folder as this code.

nomainwin

' RecordId is a number (long). The rest of the data in this structure are pointers to strings.
' The structure is read-only. ComalDB stores the records internally and then uses this structure
' to pass you the information - So DO NOT write to this structure as it contains pointers only.
'
' You CAN rename the fields in this structure to whatever you like. Your Access Database MUST
' be set-up so that the string fields have TEXT entries and if possible, but neccessarily, a
' default value string (i.e. "*") so that even if you or the user leaves a field blank it will
' automatically be filled with the default string (i.e. "*"). Default values are a good way of
' checking for valid entries as well.
'
' Each field, apart from RecordId, has a maximum string length of 50 characters. This maximum
' is defined both in comaldb and the PersonalDetails.mdb Access Database file. No strings can
' be empty (including one Space - chr$(32)) - PersonalDetails.mdb has been set-up to accommodate
' these requirements. For your own database files I suggest looking at the PersonalDetails.mdb
' file under Table Design View (Right click the title-bar of the Table and then look at it
' properties).
struct RecordPointers, _
RecordId as long, _
Title as long, _         ' Personal details
FirstName as long, _
MiddleName as long, _
LastName as long, _
Suffix as long, _        ' i.e. Snr (i.e. John White Senior)
Birthdate as long, _
Age as long, _
Sex as long, _
Nationality as long, _
Culture as long, _
SpokenLanguages as long, _
YearsInCountry as long, _
Hobbies as long, _
Building as long, _      ' Address details  (building/apartment: 23 Porter House or just 23)
Street as long, _        ' Street / Road / Way / Avenue / Grove / Cresent / Boulevard
Area as long, _          ' Area / District / Neighbourhood / Region
Town as long, _          ' Town / Province
City as long, _          ' City / State
PostCode as long, _      ' Postal Code / ZipCode
Country as long, _
HomePhone as long, _     ' Numbers details  (Telephone: Land-Line)
MobilePhone as long, _   ' Mobile / Cellular
WorkPhone1 as long, _
WorkPhone2 as long, _
Extension1 as long, _
Extension2 as long, _
Fax1 as long, _
Fax2 as long, _
Website1 as long, _      ' Internet / Email details
Website2 as long, _
Email2 as long, _
Email2 as long, _
Notes as long, _
EndMarker as long

struct RecordTitles, _
RecordId as ptr, _
Title1 as ptr, _
Title2 as ptr, _
Title3 as ptr, _
Title4 as ptr, _
Title5 as ptr, _
Title6 as ptr, _
Title7 as ptr, _
Title8 as ptr, _
Title9 as ptr, _
Title10 as ptr, _
Title11 as ptr, _
Title12 as ptr, _
Title13 as ptr, _
Title14 as ptr, _
Title15 as ptr, _
Title16 as ptr, _
Title17 as ptr, _
Title18 as ptr, _
Title19 as ptr, _
Title20 as ptr, _
Title21 as ptr, _
Title22 as ptr, _
Title23 as ptr, _
Title24 as ptr, _
Title25 as ptr, _
Title26 as ptr, _
Title27 as ptr, _
Title28 as ptr, _
Title29 as ptr, _
Title30 as ptr, _
Title31 as ptr, _
Title32 as ptr, _
Title33 as ptr, _
Title34 as ptr

struct RecordValues, _
RecordId as long, _
Value1 as ptr, _
Value2 as ptr, _
Value3 as ptr, _
Value4 as ptr, _
Value5 as ptr, _
Value6 as ptr, _
Value7 as ptr, _
Value8 as ptr, _
Value9 as ptr, _
Value10 as ptr, _
Value11 as ptr, _
Value12 as ptr, _
Value13 as ptr, _
Value14 as ptr, _
Value15 as ptr, _
Value16 as ptr, _
Value17 as ptr, _
Value18 as ptr, _
Value19 as ptr, _
Value20 as ptr, _
Value21 as ptr, _
Value22 as ptr, _
Value23 as ptr, _
Value24 as ptr, _
Value25 as ptr, _
Value26 as ptr, _
Value27 as ptr, _
Value28 as ptr, _
Value29 as ptr, _
Value30 as ptr, _
Value31 as ptr, _
Value32 as ptr, _
Value33 as ptr, _
Value34 as ptr

WindowWidth=420
WindowHeight=76
UpperLeftX=(DisplayWidth-WindowWidth)/2
UpperLeftY=(DisplayHeight-WindowHeight)/2

global recordTotal,recordNumber

recordTotal=0
recordNumber=1

' Set-up the Titles for a Database. Note: These must be filled with the, correct, Titles
' (as found in a database) as internally ComalDB does not fall back on any default titles.
' It relies purely on these titles. All errors are passed to the Debug functions, which means
' if an error occurs the dll functions fail. So no data is fetched.
RecordTitles.RecordId.struct="RecordId"
RecordTitles.Title1.struct="Title"
RecordTitles.Title2.struct="First Name"
RecordTitles.Title3.struct="Middle Name"
RecordTitles.Title4.struct="Last Name"
RecordTitles.Title5.struct="Suffix"
RecordTitles.Title6.struct="Birthdate"
RecordTitles.Title7.struct="Age"
RecordTitles.Title8.struct="Sex"
RecordTitles.Title9.struct="Nationality"
RecordTitles.Title10.struct="Culture"
RecordTitles.Title11.struct="Spoken Languages"
RecordTitles.Title12.struct="Years In This Country"
RecordTitles.Title13.struct="Hobbies"
RecordTitles.Title14.struct="Building"
RecordTitles.Title15.struct="Street"
RecordTitles.Title16.struct="Area"
RecordTitles.Title17.struct="Town"
RecordTitles.Title18.struct="City"
RecordTitles.Title19.struct="Post Code"
RecordTitles.Title20.struct="Country"
RecordTitles.Title21.struct="Home Phone"
RecordTitles.Title22.struct="Mobile Phone"
RecordTitles.Title23.struct="Work Phone1"
RecordTitles.Title24.struct="Work Phone2"
RecordTitles.Title25.struct="Extension1"
RecordTitles.Title26.struct="Extension2"
RecordTitles.Title27.struct="Fax1"
RecordTitles.Title28.struct="Fax2"
RecordTitles.Title29.struct="Website1"
RecordTitles.Title30.struct="Website2"
RecordTitles.Title31.struct="Email Address1"
RecordTitles.Title32.struct="Email Address2"
RecordTitles.Title33.struct="Notes"
RecordTitles.Title34.struct="End Marker"

' Set-up the Values for the Titles.
'
' In Access RecordId is very good because it acts as an Insert() function as well. So if you
' had IDs of 3,9 and 5 it would put record 3 and then 9 as expected (in order). However. You might
' then think 5 would be put at the bottom (after 9) to denote the last item in the list, but
' you would be wrong as 5 would go in between 3 and 9. So use RecordId to your advantage.
' Note. Two IDs cannot be the same. If you have already inserted a record with ID 5, change
' that record in Liberty Basic and then try to insert it again (with the new changes) it will
' not be inserted as it will be trying to overwrite an already existing/inserted record 5.
RecordValues.RecordId.struct=17
RecordValues.Value1.struct="Mr"
RecordValues.Value2.struct="David"
RecordValues.Value3.struct="James"
RecordValues.Value4.struct="Peterson"
RecordValues.Value5.struct="Senior"
RecordValues.Value6.struct="*"  '18\12\76"
RecordValues.Value7.struct="44"
RecordValues.Value8.struct="Male"
RecordValues.Value9.struct="French"
RecordValues.Value10.struct="French"
RecordValues.Value11.struct="French and English"
RecordValues.Value12.struct="2 Years"
RecordValues.Value13.struct="None"
RecordValues.Value14.struct="Flat 28b"
RecordValues.Value15.struct="Mansfield Road"
RecordValues.Value16.struct="Sherwood Rise"
RecordValues.Value17.struct="Sherwood"
RecordValues.Value18.struct="Nottingham"
RecordValues.Value19.struct="NG8 9CX"
RecordValues.Value20.struct="England"
RecordValues.Value21.struct="One"
RecordValues.Value22.struct="Two"
RecordValues.Value23.struct="Three"
RecordValues.Value24.struct="Four"
RecordValues.Value25.struct="Five"
RecordValues.Value26.struct="Six"
RecordValues.Value27.struct="*"
RecordValues.Value28.struct="*"
RecordValues.Value29.struct="*"
RecordValues.Value30.struct="*"
RecordValues.Value31.struct="*"
RecordValues.Value32.struct="*"
RecordValues.Value33.struct="Not contact via the Phone or Internet."
RecordValues.Value34.struct="END"

button #Form.B1, "Get Records", [BC1], ul, 6, 6, 100, 30
button #Form.B2, "Move/Add/Delete", [BC2], ul, 126, 6, 120, 30
button #Form.B3, "How Many Records", [BC3], ul, 266, 6, 120, 30

stylebits #Form,0,0,_WS_EX_TOPMOST,0

open "COMAL - COM Access Library." for dialog as #Form
#Form "trapclose [quit.Form]"
open "comaldb.dll" for dll as #comaldb
wait

[BC1]
' recordNumber is here for the demo. Normally you would keep track of recordNumber outside
' of this BC1 routine.
recordNumber=1
' Connect to Access and open (invisibly) the PersonalDetails.mdb file.
rtn=DBConnectToAccess("PersonalDetails.mdb")
if rtn=1 then
' Open the Contacts table and then get its Records.
recordTotal=DBGetAllRecords(,"Contacts")
if recordTotal>0 then
if (recordNumber=recordTotal or recordNumber<recordTotal) then
' Get one record and display some of its values.
rtn=DBGetRecord(recordNumber-1)
notice "Record Total: "+str$(recordTotal)
notice "Record ID: "+str$(RecordPointers.RecordId.struct)
notice "Title: "+winstring(RecordPointers.Title.struct)
end if
else
notice "Empty Database"
end if
' Disconnect from Access.
rtn=DBDisconnectFromAccess()
end if
wait

[BC2]
' Connect to Access and open (invisibly) the PersonalDetails.mdb file.
rtn=DBConnectToAccess("PersonalDetails.mdb")
if rtn=1 then
' Open the Contacts table and a connection to its records.
rtn=RECORDSOpen("Contacts")
if rtn=1 then
' Count how many records there are in the Contacts table.
rtn=RECORDSGetCount()
if rtn>0 then
' Move the cursor to a new position.
rtn=RECORDMoveToLast()
' Change the last record's field (First Name) value to "1. LAST".
rtn=RECORDChangeField("First Name","1. LAST")
rtn=RECORDMoveUp()
rtn=RECORDChangeField("First Name","2. UP ONE (2nd to last)")
rtn=RECORDMoveToFirst()
rtn=RECORDChangeField("First Name","3. FIRST (1)")
rtn=RECORDMoveDown()
rtn=RECORDChangeField("First Name","4. DOWN ONE (2)")
rtn=RECORDMoveTo(2)  ' Positive values = Down.
rtn=RECORDChangeField("First Name","5. DOWN TWO MORE (4)")
rtn=RECORDMoveTo(-1) ' Negative values = Up.
rtn=RECORDChangeField("First Name","6. UP ONE (3)")
' Add a new Record to the Contacts table.
rtn=RECORDAdd()
' Delete a Record from the Contacts table.
rtn=RECORDMoveTo(-2)
rtn=RECORDDelete()
else
notice "Empty Database"
end if
' Close the connection to the records and then close the Contacts table.
rtn=RECORDSClose()
end if
' close (invisibly) the PersonalDetails.mdb file (Technical: The internal counter)
' and then Disconnect from Access.
rtn=DBDisconnectFromAccess()
end if
wait

[BC3]
' Connect to Access and open (invisibly) the PersonalDetails.mdb file.
rtn=DBConnectToAccess("PersonalDetails.mdb")
if rtn=1 then
' Open the Contacts table and a connection to its records.
rtn=RECORDSOpen("Contacts")
if rtn=1 then
' Count how many records there are in the Contacts table.
rtn=RECORDSGetCount()
notice "Record Count: "+str$(rtn)
' Close the connection to the records and then close the Contacts table.
rtn=RECORDSClose()
end if
' close (invisibly) the PersonalDetails.mdb file (Technical: The internal counter)
' and then Disconnect from Access.
rtn=DBDisconnectFromAccess()
end if
wait

[quit.Form]
close #Form
close #comaldb
end

' close (invisibly) the .mdb file and then Disconnect from Access.
function DBDisconnectFromAccess()
calldll #comaldb,"DB_DisconnectFromAccess",DBDisconnectFromAccess as Long
end function

' Connect to Access and open (invisibly) the .mdb file.
function DBConnectToAccess(fname$)
calldll #comaldb,"DB_ConnectToAccess",fname$ as ptr,DBConnectToAccess as Long
end function

' Get one record, by number (index) - See DBGetAllRecords() below.
function DBGetRecord(number)
calldll #comaldb,"DB_GetRecord",number as long,RecordPointers as struct,DBGetRecord as Long
end function

' Open a table (tableName$) and then get its Records (internally with comaldb) - You then need
' to use DBGetRecord(number) to retrieve the data of a particular record number.
function DBGetAllRecords(tableName$)
calldll #comaldb,"DB_GetAllRecords",tableName$ as ptr,RecordTitles as struct,DBGetAllRecords as Long
end function

' Delete a Record from the current table.
function RECORDDelete()
calldll #comaldb,"RECORD_Delete",RECORDDelete as Long
end function

' Add a new Record to the current table.
function RECORDAdd()
calldll #comaldb,"RECORD_Add",RecordTitles as struct,RecordValues as struct,RECORDAdd as Long
end function

' Move the record cursor to the first record.
function RECORDMoveToFirst()
calldll #comaldb,"RECORD_MoveToFirst",RECORDMoveToFirst as Long
end function

' Move the record cursor to the last record.
function RECORDMoveToLast()
calldll #comaldb,"RECORD_MoveToLast",RECORDMoveToLast as Long
end function

' Move the record cursor up one record.
function RECORDMoveUp()
calldll #comaldb,"RECORD_MoveUp",RECORDMoveUp as Long
end function

' Move the record cursor down one record.
function RECORDMoveDown()
calldll #comaldb,"RECORD_MoveDown",RECORDMoveDown as Long
end function

' Move the record cursor to the ??? record.
function RECORDMoveTo(position)
calldll #comaldb,"RECORD_MoveTo",position as long,RECORDMoveTo as Long
end function

' Change a field's (field$) value (value$) in the current record.
function RECORDChangeField(field$,value$)
calldll #comaldb,"RECORD_ChangeField",field$ as ptr,value$ as ptr,RECORDChangeField as Long
end function

' Count how many records there are in the current table.
function RECORDSGetCount()
calldll #comaldb,"RECORDS_GetCount",RECORDSGetCount as Long
end function

' Close the connection to the current records and then close its table.
function RECORDSClose()
calldll #comaldb,"RECORDS_Close",RECORDSClose as Long
end function

' Open the current table (tableName$) and a connection to its records.
function RECORDSOpen(tableName$)
calldll #comaldb,"RECORDS_Open",tableName$ as ptr,RECORDSOpen as Long
end function

