' COMAL - COM Access Library. COMAL (Pronounced COM UL).
'
' ComalSpeech.dll is a Dynamic Linked Library written by me,
' John White, for myself and any programming language that
' can utilize it.
'
' Website: http://www.yoingco.com/
'   Email: john@yoingco.com
'
' Tested   on:  Windows XP (SP2) Home Edition (Genuine).
'        with:  Microsoft Office Standard Edition 2003 (SP2) Trial (Genuine).
'        Date:  28th February 2006.

nomainwin

global FALSE, TRUE, OFF, ONN, NO, YES
global sartn,sa2rtn,sa3rtn,sa4rtn

FALSE=0
TRUE=1
OFF=0
ONN=1
NO=0
YES=1

ANIM.Alert=1
ANIM.Announce=2
ANIM.Blink=3
ANIM.Confused=4
ANIM.Trophy=5
ANIM.Clapping=6
ANIM.Decline=7
ANIM.MagicWand=8
ANIM.PuffOfSmoke=9
ANIM.DoNotRecognize=10
ANIM.Explain=11
ANIM.GestureDown=12
ANIM.GestureUp=13
ANIM.GestureLeft=14
ANIM.GestureRight=15
ANIM.GetAttention=16
ANIM.Idle=17
ANIM.LookDown=18
ANIM.LookUp=19
ANIM.LookLeft=20
ANIM.LookRight=21
ANIM.MoveDown=22
ANIM.MoveUp=23
ANIM.MoveLeft=24
ANIM.MoveRight=25
ANIM.Pleased=26
ANIM.Process=27
ANIM.Read=28
ANIM.Resting=29
ANIM.Sad=30
ANIM.Search=31
ANIM.StartListening=32
ANIM.StopListening=33
ANIM.Suggest=34
ANIM.Surprised=35
ANIM.Think=36
ANIM.Uncertain=37
ANIM.Wave=38
ANIM.Write=39
ANIM.Processing=40
ANIM.Reading=41
ANIM.Searching=42
ANIM.Writing=43

sartn=FALSE
sa2rtn=FALSE
sa3rtn=FALSE
sa4rtn=FALSE

WindowWidth=710
WindowHeight=76
UpperLeftX=(DisplayWidth-WindowWidth)/2
UpperLeftY=(DisplayHeight-WindowHeight)/2

button #Form.B1, "SPEECH Agent 1", [BC1], ul, 6, 6, 120, 30
button #Form.B2, "SPEECH Agent 2", [BC2], ul, 146, 6, 120, 30
button #Form.B3, "SPEECH Agent 3", [BC3], ul, 286, 6, 120, 30
button #Form.B4, "SPEECH Agent 4", [BC4], ul, 426, 6, 120, 30
button #Form.B5, "Stop Animation", [BC5], ul, 566, 6, 120, 30

stylebits #Form,0,0,_WS_EX_TOPMOST,0

open "COMAL - COM Access Library." for dialog as #Form
#Form "trapclose [quit.Form]"
open "comalspeech.dll" for dll as #comal
wait

[BC1]
sartn=SpeechOpen("Merlin")
'sartn=SpeechOpenAgent("merlin","C:\Windows\msagent\chars\merlin.acs")
'if sartn then
rtn=AgentAnimate(ANIM.Announce)
rtn=AgentSpeak("\chr="+chr$(34)+"whisper"+chr$(34)+"\Please speak very quietly whilst in the Library",TRUE)
rtn=AgentMoveTo(300,300)
rtn=AgentAnimate(ANIM.MagicWand)
rtn=AgentSpeak("\chr="+Chr$(34)+"whisper"+Chr$(34)+"\Hello!"+"\chr="+Chr$(34)+"normal"+Chr$(34)+"\I am out of the Library now",TRUE)
rtn=AgentMoveTo(30,30)
rtn=AgentSpeak("For 2 seconds, I will PAUSE\pau=2000\for thought",TRUE)
rtn=AgentAnimate(ANIM.Trophy)
rtn=AgentMoveTo(200,200)
rtn=AgentGestureAt(200,200)
rtn=AgentMoveTo(200,200)
rtn=AgentShowPopupMenu(200,200)
'sartn=FALSE
'end if
wait

[BC2]
sa2rtn=Speech2OpenAgent("robby","C:\Windows\msagent\chars\robby.acs")
if sa2rtn then
rtn=SpeechCountVoices()
notice "Voices #"+str$(rtn)
rtn=Agent2Hide(FALSE,TRUE)
rtn=Agent2Animate(ANIM.Announce)
rtn=Agent2Speak("\chr="+chr$(34)+"whisper"+chr$(34)+"\I have decided to Whisper",TRUE)
rtn=Agent2MoveTo(500,400)
rtn=Agent2ShowPopupMenu(500,400)
'sa2rtn=FALSE
end if
wait

[BC3]
sa3rtn=Speech3OpenAgent("peedy","C:\Windows\msagent\chars\peedy.acs")
if sa3rtn then
rtn=Agent3Hide(FALSE,TRUE)
rtn=Agent3Animate(ANIM.Announce)
rtn=Agent3Speak("Hello. My name is Peedy",TRUE)
rtn=Agent3MoveTo(700,500)
rtn=Agent3ShowPopupMenu(700,500)
'sa3rtn=FALSE
end if
wait

[BC4]
sa4rtn=Speech4OpenAgent("genie","C:\Windows\msagent\chars\genie.acs")
if sa4rtn then
rtn=Agent4Hide(FALSE,TRUE)
rtn=Agent4Animate(ANIM.Announce)
rtn=Agent4Speak("My first wish is to be in charge of the World",TRUE)
rtn=Agent4Speak("My second wish is to rid the world of bad things",TRUE)
rtn=Agent4Speak("My third wish is to join the good world!",TRUE)
rtn=Agent4MoveTo(300,500)
rtn=Agent4ShowPopupMenu(300,500)
'sa4rtn=FALSE
end if
wait

[BC5]
rtn=SpeechStopAnimation()
wait

[quit.Form]
call CleanUpCOMAL
close #Form
close #comal
end

sub CleanUpCOMAL
if sartn then
rtn=SpeechClose()
end if
if sa2rtn then
rtn=Speech2Close()
end if
if sa3rtn then
rtn=Speech3Close()
end if
end sub

function SpeechClose()
calldll #comal,"SPEECH_Close",SpeechClose as Long
end function

function Speech2Close()
calldll #comal,"SPEECH2_Close",Speech2Close as Long
end function

function Speech3Close()
calldll #comal,"SPEECH3_Close",Speech3Close as Long
end function

function Speech4Close()
calldll #comal,"SPEECH4_Close",Speech4Close as Long
end function

function SpeechOpen(agentName$)
calldll #comal,"SPEECH_Open",agentName$ as ptr,SpeechOpen as long
end function

function Speech2Open(agentName$)
calldll #comal,"SPEECH2_Open",agentName$ as ptr,Speech2Open as long
end function

function Speech3Open(agentName$)
calldll #comal,"SPEECH3_Open",agentName$ as ptr,Speech3Open as long
end function

function Speech4Open(agentName$)
calldll #comal,"SPEECH4_Open",agentName$ as ptr,Speech4Open as long
end function

function SpeechOpenAgent(agentName$,acsPathName$)
calldll #comal,"SPEECH_OpenAgent",agentName$ as ptr,acsPathName$ as ptr,SpeechOpenAgent as long
end function

function Speech2OpenAgent(agentName$,acsPathName$)
calldll #comal,"SPEECH2_OpenAgent",agentName$ as ptr,acsPathName$ as ptr,Speech2OpenAgent as long
end function

function Speech3OpenAgent(agentName$,acsPathName$)
calldll #comal,"SPEECH3_OpenAgent",agentName$ as ptr,acsPathName$ as ptr,Speech3OpenAgent as long
end function

function Speech4OpenAgent(agentName$,acsPathName$)
calldll #comal,"SPEECH4_OpenAgent",agentName$ as ptr,acsPathName$ as ptr,Speech4OpenAgent as long
end function

function SpeechCountVoices()
calldll #comal,"SPEECH_CountVoices",SpeechCountVoices as Long
end function

function SpeechSoundEffects(onoff)
calldll #comal,"SPEECH_SoundEffects",onoff as long,SpeechSoundEffects as long
end function

function Speech2SoundEffects(onoff)
calldll #comal,"SPEECH2_SoundEffects",onoff as long,Speech2SoundEffects as long
end function

function Speech3SoundEffects(onoff)
calldll #comal,"SPEECH3_SoundEffects",onoff as long,Speech3SoundEffects as long
end function

function Speech4SoundEffects(onoff)
calldll #comal,"SPEECH4_SoundEffects",onoff as long,Speech4SoundEffects as long
end function

function SpeechStopAnimation()
calldll #comal,"SPEECH_StopAnimation",SpeechStopAnimation as long
end function

function Speech2StopAnimation()
calldll #comal,"SPEECH2_StopAnimation",Speech2StopAnimation as long
end function

function Speech3StopAnimation()
calldll #comal,"SPEECH3_StopAnimation",Speech3StopAnimation as long
end function

function Speech4StopAnimation()
calldll #comal,"SPEECH4_StopAnimation",Speech4StopAnimation as long
end function

function AgentHide(showAgent,playHideAnimation)
calldll #comal,"AGENT_Hide",showAgent as long,playHideAnimation as long,AgentHide as long
end function

function Agent2Hide(showAgent,playHideAnimation)
calldll #comal,"AGENT2_Hide",showAgent as long,playHideAnimation as long,Agent2Hide as long
end function

function Agent3Hide(showAgent,playHideAnimation)
calldll #comal,"AGENT3_Hide",showAgent as long,playHideAnimation as long,Agent3Hide as long
end function

function Agent4Hide(showAgent,playHideAnimation)
calldll #comal,"AGENT4_Hide",showAgent as long,playHideAnimation as long,Agent4Hide as long
end function

function AgentSpeak(textString$,showAgent)
calldll #comal,"AGENT_Speak",textString$ as ptr,showAgent as long,AgentSpeak as long
end function

function Agent2Speak(textString$,showAgent)
calldll #comal,"AGENT2_Speak",textString$ as ptr,showAgent as long,Agent2Speak as long
end function

function Agent3Speak(textString$,showAgent)
calldll #comal,"AGENT3_Speak",textString$ as ptr,showAgent as long,Agent3Speak as long
end function

function Agent4Speak(textString$,showAgent)
calldll #comal,"AGENT4_Speak",textString$ as ptr,showAgent as long,Agent4Speak as long
end function

function AgentAnimate(movement)
calldll #comal,"AGENT_Animate",movement as long,AgentAnimate as long
end function

function Agent2Animate(movement)
calldll #comal,"AGENT2_Animate",movement as long,Agent2Animate as long
end function

function Agent3Animate(movement)
calldll #comal,"AGENT3_Animate",movement as long,Agent3Animate as long
end function

function Agent4Animate(movement)
calldll #comal,"AGENT4_Animate",movement as long,Agent4Animate as long
end function

function AgentMoveTo(x,y)
calldll #comal,"AGENT_MoveTo",x as long,y as long,AgentMoveTo as long
end function

function Agent2MoveTo(x,y)
calldll #comal,"AGENT2_MoveTo",x as long,y as long,Agent2MoveTo as long
end function

function Agent3MoveTo(x,y)
calldll #comal,"AGENT3_MoveTo",x as long,y as long,Agent3MoveTo as long
end function

function Agent4MoveTo(x,y)
calldll #comal,"AGENT4_MoveTo",x as long,y as long,Agent4MoveTo as long
end function

function AgentGestureAt(x,y)
calldll #comal,"AGENT_GestureAt",x as long,y as long,AgentGestureAt as long
end function

function Agent2GestureAt(x,y)
calldll #comal,"AGENT2_GestureAt",x as long,y as long,Agent2GestureAt as long
end function

function Agent3GestureAt(x,y)
calldll #comal,"AGENT3_GestureAt",x as long,y as long,Agent3GestureAt as long
end function

function Agent4GestureAt(x,y)
calldll #comal,"AGENT4_GestureAt",x as long,y as long,Agent4GestureAt as long
end function

function AgentShowPopupMenu(x,y)
calldll #comal,"AGENT_ShowPopupMenu",x as long,y as long,AgentShowPopupMenu as long
end function

function Agent2ShowPopupMenu(x,y)
calldll #comal,"AGENT2_ShowPopupMenu",x as long,y as long,Agent2ShowPopupMenu as long
end function

function Agent3ShowPopupMenu(x,y)
calldll #comal,"AGENT3_ShowPopupMenu",x as long,y as long,Agent3ShowPopupMenu as long
end function

function Agent4ShowPopupMenu(x,y)
calldll #comal,"AGENT4_ShowPopupMenu",x as long,y as long,Agent4ShowPopupMenu as long
end function

function AgentThink(textString$,showAgent)
calldll #comal,"AGENT_Think",textString$ as ptr,showAgent as long,AgentThink as long
end function

function Agent2Think(textString$,showAgent)
calldll #comal,"AGENT2_Think",textString$ as ptr,showAgent as long,Agent2Think as long
end function

function Agent3Think(textString$,showAgent)
calldll #comal,"AGENT3_Think",textString$ as ptr,showAgent as long,Agent3Think as long
end function

function Agent4Think(textString$,showAgent)
calldll #comal,"AGENT4_Think",textString$ as ptr,showAgent as long,Agent4Think as long
end function

function AgentAnimateWhenIdle(yesno)
calldll #comal,"AGENT_AnimateWhenIdle",yesno as long,AgentThink as long
end function

function Agent2AnimateWhenIdle(yesno)
calldll #comal,"AGENT2_AnimateWhenIdle",yesno as long,Agent2Think as long
end function

function Agent3AnimateWhenIdle(yesno)
calldll #comal,"AGENT3_AnimateWhenIdle",yesno as long,Agent3Think as long
end function

function Agent4AnimateWhenIdle(yesno)
calldll #comal,"AGENT4_AnimateWhenIdle",yesno as long,Agent4Think as long
end function

function AgentChangeSize(left,top,width,height)
calldll #comal,"AGENT_ChangeSize",left as long,top as long,width as long,height as long,AgentChangeSize as long
end function

function Agent2ChangeSize(left,top,width,height)
calldll #comal,"AGENT2_ChangeSize",left as long,top as long,width as long,height as long,Agent2ChangeSize as long
end function

function Agent3ChangeSize(left,top,width,height)
calldll #comal,"AGENT3_ChangeSize",left as long,top as long,width as long,height as long,Agent3ChangeSize as long
end function

function Agent4ChangeSize(left,top,width,height)
calldll #comal,"AGENT4_ChangeSize",left as long,top as long,width as long,height as long,Agent4ChangeSize as long
end function

