' COMAL - COM Access Library. COMAL (Pronounced COM UL).
'
' ComalWord.dll is a Dynamic Linked Library written by me,
' John White, for myself and any programming language that
' can utilize it.
'
' Website: http://www.yoingco.com/
'   Email: john@yoingco.com
'
' Tested   on:  Windows XP (SP2) Home Edition (Genuine).
'        with:  Microsoft Office Standard Edition 2003 (SP2) Trial (Genuine).
'        Date:  28th February 2006.
'
' This demo needs a file called Macro_Example.doc in the C: (Hard Drive) folder.
' To run this demo click on the Open File button first and then on the Run Macro button.

nomainwin

global FALSE, TRUE, OFF, ONN, NO, YES
global wdrtn

FALSE=0
TRUE=1
OFF=0
ONN=1
NO=0
YES=1

' WCANVAS_CreateCanvas()
CANVAS1=1
CANVAS2=2
CANVAS3=3
CANVAS4=4

' WDOCUMENT_ChangeView()
WEBPAGEPREVIEW=1
NORMAL.VIEW=1
OUTLINE.VIEW=2
PRINT.VIEW=3
PRINTPREVIEW.VIEW=4
OUTLINE.VIEW.AGAIN=5
WEB.VIEW=6

' Border LineStyles
BS.Double=7
BS.Embossed3D=21
BS.Engraved3D=22

' Textures
BGP.27HalfPercent=275

' Bias
Bias.Default=0
Bias.FarEast=1
Bias.DontCare=255

' Paragraph Alignment
Align.Left=0
Align.Center=1
Align.Right=2
Align.Justify=3

' Breaks
PageBreak=7

wdrtn=FALSE

WindowWidth=310
WindowHeight=76
UpperLeftX=(DisplayWidth-WindowWidth)/2
UpperLeftY=(DisplayHeight-WindowHeight)/2

button #Form.B1, "Open File", [BC1], ul, 6, 6, 80, 30
button #Form.B2, "Print", [BC2], ul, 106, 6, 80, 30
button #Form.B3, "Run Macro", [BC3], ul, 206, 6, 80, 30

stylebits #Form,0,0,_WS_EX_TOPMOST,0

open "COMAL - COM Access Library." for dialog as #Form
#Form "trapclose [quit.Form]"
open "comalword.dll" for dll as #comal
wait

[BC1]
wdrtn=WDOCOpen(NO,YES,"C:\Macro_Example.doc")
if wdrtn=TRUE then

wdrtn=FALSE
end if
wait

[BC2]
'rtn=WDOCPrintSelectedPages("1,3")
'rtn=WDOCPrintToFile("C:\Test.prn")
'rtn=WDOCPrintAll()
rtn=WDOCPrintCurrentPage()
if rtn=FALSE then
' File went through the Spooler
end if
wait

[BC3]
rtn=WMACRORun("Macro1")
wait

[quit.Form]
call CleanUpCOMAL
close #Form
close #comal
end

sub CleanUpCOMAL
'if wdrtn=TRUE then
rtn=WDOCClose()
wdrtn=FALSE
'end if
end sub

function WDOCClose()
calldll #comal,"WDOCUMENT_Close",WDOCClose as Long
end function

function WDOCSave()
calldll #comal,"WDOCUMENT_Save",WDOCSave as Long
end function

function WDOCSaveAs(fileName$,fileType)
calldll #comal,"WDOCUMENT_SaveAs",fileName$ as ptr,fileType as long,WDOCSaveAs as Long
end function

function WDOCOpen(yesNo,useFile,fileName$)
calldll #comal,"WDOCUMENT_Open",onOff as long,useFile as long,fileName$ as ptr,WDOCOpen as Long
end function

function WDOCGetName()
calldll #comal,"WDOCUMENT_GetName",WDOCGetName as Long
end function

function WDOCPrintAll()
calldll #comal,"WDOCUMENT_PrintAll",WDOCPrintAll as Long
end function

function WDOCPrintCurrentPage()
calldll #comal,"WDOCUMENT_PrintCurrentPage",WDOCPrintCurrentPage as Long
end function

function WDOCPrintToFile(fileName$)
calldll #comal,"WDOCUMENT_PrintToFile",fileName$ as ptr,WDOCPrintToFile as Long
end function

function WDOCPrintSelectedPages(pages$)
calldll #comal,"WDOCUMENT_PrintSelectedPages",pages$ as ptr,WDOCPrintSelectedPages as Long
end function

function WDOCChangeView(view)
calldll #comal,"WDOCUMENT_ChangeView",view as long,WDOCChangeView as Long
end function

function WORDGetDefaultPrinter()
calldll #comal,"WORD_GetDefaultPrinter",WORDGetDefaultPrinter as Long
end function

function WORDSetDefaultPrinter(printerName$)
calldll #comal,"WORD_SetDefaultPrinter",printerName$ as ptr,WORDSetDefaultPrinter as Long
end function

function WFONTSetOnOff(command,onoff)
calldll #comal,"WFONT_SetOnOff",command as long,onoff as long,WFONTSetOnOff as Long
end function

function WFONTSetName(fontName$)
calldll #comal,"WFONT_SetName",fontName$ as ptr,WFONTSetName as Long
end function

function WFONTSetColourIndex(colourIndex)
calldll #comal,"WFONT_SetColourIndex",colourIndex as long,WFONTSetColourIndex as Long
end function

function WFONTSetColour(colour)
calldll #comal,"WFONT_SetColour",colour as long,WFONTSetColour as Long
end function

function WFONTSetSize(fontSize)
calldll #comal,"WFONT_SetSize",fontSize as long,WFONTSetSize as Long
end function

function WFONTSetFont(fontName$,fontSize,smallCaps,colour,bold,underline,italic,strikethrough,shadow)
calldll #comal,"WFONT_SetFont",fontName$ as ptr,fontSize as long,smallCaps as long,colour as long,bold as long,underline as long,italic as long,strikethrough as long,shadow as long,WFONTSetFont as Long
end function

function WFONTSetRangeFont(fontName$,fontSize,smallCaps,colour,bold,underline,italic,strikethrough,shadow)
calldll #comal,"WFONT_SetRangeFont",fontName$ as ptr,fontSize as long,smallCaps as long,colour as long,bold as long,underline as long,italic as long,strikethrough as long,shadow as long,WFONTSetRangeFont as Long
end function

function WPARAGRAPHInsert()
calldll #comal,"WPARAGRAPH_Insert",WPARAGRAPHInsert as Long
end function

function WPARAGRAPHAdd()
calldll #comal,"WPARAGRAPH_Add",WPARAGRAPHAdd as Long
end function

function WPARAGRAPHAlign(lcr)
calldll #comal,"WPARAGRAPH_Align",lcr as long,WPARAGRAPHAlign as Long
end function

function WPARAGRAPHAddShape(shapeNumber,left,top,width,height,wrapFormat,wrapSide,lineColour,fgColour,flipIt)
calldll #comal,"WPARAGRAPH_AddShape",shapeNumber as long,left as long,top as long,width as long,height as long,wrapFormat as long,wrapSide as long,lineColour as long,fgColour as long,flipIt as long,WPARAGRAPHAddShape as Long
end function

function WPARAGRAPHAddPicture(fileName$,link,save,left,top,width,height,wrapFormat,wrapSide)
calldll #comal,"WPARAGRAPH_AddPicture",fileName$ as ptr,link as long,save as long,left as long,top as long,width as long,height as long,wrapFormat as long,wrapSide as long,WPARAGRAPHAddPicture as Long
end function

function WTEXTWriteText(textString$)
calldll #comal,"WTEXT_WriteText",textString$ as ptr,WTEXTWriteText as Long
end function

function WTEXTWriteBorderedText(textString$,lineStyle,lineColour,texture,bgColour,fgColour,shadow,alignment,leftIndent,rightIndent)
calldll #comal,"WTEXT_WriteBorderedText",textString$ as ptr,lineStyle as long,lineColour as long,texture as long,bgColour as long,fgColour as long,shadow as long,alignment as long,leftIndent as long,rightIndent as long,WTEXTWriteBorderedText as Long
end function

function WCANVASCreateCanvas(canvasNumber,left,top,width,height)
calldll #comal,"WCANVAS_CreateCanvas",canvasNumber as long,left as long,top as long,width as long,height as long,WCANVASCreateCanvas as Long
end function

function WCANVASDrawTextBox(canvasNumber,textOrientation,left,top,width,height,textString$)
calldll #comal,"WCANVAS_DrawTextBox",canvasNumber as long,textOrientation as long,left as long,top as long,width as long,height as long,textString$ as ptr,WCANVASDrawTextBox as Long
end function

function WCANVASDrawLine(canvasNumber,left,top,right,bottom,fgColour,barrowLength,barrowStyle,barrowWidth,earrowLength,earrowStyle,earrowWidth,thickness,lineStyle)
calldll #comal,"WCANVAS_DrawLine",canvasNumber as long,left as long,top as long,right as long,bottom as long,fgColour as long,barrowLength as long,barrowStyle as long,barrowWidth as long,earrowLength as long,earrowStyle as long,earrowWidth as long,thickness as long,lineStyle as long,WCANVASDrawLine as Long
end function

function WCANVASDrawShape(canvasNumber,shapeNumber,left,top,width,height,lineColour,fillColour,flipIt)
calldll #comal,"WCANVAS_DrawShape",canvasNumber as long,shapeNumber as long,left as long,top as long,width as long,height as long,lineColour as long,fillColour as long,flipIt as long,CANVASDrawShape as long
end function

function WCANVASDrawLabel(canvasNumber,textOrientation,left,top,width,height,textString$,fgColour,bgColour,useGradient,direction,gradient,fontName$,fontSize,bold,italic,underline,shadow,strikethrough,smallCaps)
calldll #comal,"WCANVAS_DrawLabel",canvasNumber as long,textOrientation as long,left as long,top as long,width as long,height as long,textString$ as ptr,fgColour as long,bgColour as long,useGradient as long,direction as long,gradient as long,fontName$ as ptr,fontSize as long,bold as long,italic as long,underline as long,shadow as long,strikethrough as long,smallCaps as long,WCANVASDrawLabel as long
end function

function WCANVASWordArt(canvasNumber,shapeNumber,textString$,fontName$,fontSize,bold,italic,leftPointPos$,topPointPos$,rotation$)
calldll #comal,"WCANVAS_WordArt",canvasNumber as long,shapeNumber as long,textString$ as ptr,fontName$ as ptr,fontSize as long,bold as long,italic as long,leftPointPos$ as ptr,topPointPos$ as ptr,rotation$ as ptr,WCANVASWordArt as long
end function

function WINSERTSystemDateTime()
calldll #comal,"WINSERT_SystemDateTime",WINSERTSystemDateTime as long
end function

function WINSERTDateTime(dateFormat$,asField,twoDigits)
calldll #comal,"WINSERT_DateTime",dateFormat$ as ptr,asField as long,twoDigits as long,WINSERTDateTime as long
end function

function WINSERTSymbol(code,fontName$,useUnicode,bias)
calldll #comal,"WINSERT_Symbol",code as long,fontName$ as ptr,useUnicode as long,bias as long,WINSERTSymbol as long
end function

function WINSERTHyperLink(linkName$,screenTip$,displayText$)
calldll #comal,"WINSERT_HyperLink",linkName$ as ptr,screenTip$ as ptr,displayText$ as ptr,WINSERTHyperLink as long
end function

function WINSERTAutoText(textString$)
calldll #comal,"WINSERT_AutoText",textString$ as ptr,WINSERTAutoText as long
end function

function WINSERTBreak(breakType)
calldll #comal,"WINSERT_Break",breakType as long,WINSERTBreak as long
end function

function WINSERTPicture(canvasNumber,fileName$,link,saveWithDoc,left,top,width,height)
calldll #comal,"WINSERT_Picture",canvasNumber as long,fileName$ as ptr,link as long,saveWithDoc as long,left as long,top as long,width as long,height as long,WINSERTPicture as long
end function

function WINSERTFile(fileName$,range,promptUser)
calldll #comal,"WINSERT_File",fileName$ as ptr,range as ptr,promptUser as long,WINSERTFile as long
end function

function WINSERTParagraph(textString$,rangeStart,rangeEnd)
calldll #comal,"WINSERT_Paragraph",textString$ as ptr,rangeStart as long,rangeEnd as long,WINSERTParagraph as long
end function

function WSETTINGSetOnOff(command,onOff,number)
calldll #comal,"WSETTING_SetOnOff",command as long,onOff as long,number as long,WSETTINGSetOnOff as long
end function

function WAGENTSetUp(title$,buttons,buttonType,item1$,item2$,item3$,item4$,item5$,x,y)
calldll #comal,"WAGENT_SetUp",title$ as ptr,buttons as long,buttonType as long,item1$ as ptr,item2$ as ptr,item3$ as ptr,item4$ as ptr,item5$ as ptr,x as long,y as long,WAGENTSetUp as long
end function

function WMACRORun(macroName$)
calldll #comal,"WMACRO_Run",macroName$ as ptr,WMACRORun as long
end function

