#include <disphelper.c>

#define VER_PLATFORM_WIN32_CE 3

typedef struct stringInfo
{
char rtnStg[256];
} stringData;

stringData sd;
stringData * sdPtr;

typedef struct RecordInfo
{
int id;
char title[50];
char first[50];
char middle[50];
char last[50];
char suffix[50];
char birth[50];
char age[50];
char sex[50];
char nationality[50];
char culture[50];
char languages[50];
char years[50];
char hobbies[50];
char building[50];
char street[50];
char area[50];
char town[50];
char city[50];
char pcode[50];
char country[50];
char home[50];
char mobile[50];
char work1[50];
char work2[50];
char ext1[50];
char ext2[50];
char fax1[50];
char fax2[50];
char web1[50];
char web2[50];
char email1[50];
char email2[50];
char notes[50];
char endmarker[50];
} RecordData;

RecordData rd[5000];

struct RecordPointers
{
int id;
int title;
int first;
int middle;
int last;
int suffix;
int birth;
int age;
int sex;
int nationality;
int culture;
int languages;
int years;
int hobbies;
int building;
int street;
int area;
int town;
int city;
int pcode;
int country;
int home;
int mobile;
int work1;
int work2;
int ext1;
int ext2;
int fax1;
int fax2;
int web1;
int web2;
int email1;
int email2;
int notes;
int endmarker;
};

struct RecordTitles
{
int RecordId;
int tn1;
int tn2;
int tn3;
int tn4;
int tn5;
int tn6;
int tn7;
int tn8;
int tn9;
int tn10;
int tn11;
int tn12;
int tn13;
int tn14;
int tn15;
int tn16;
int tn17;
int tn18;
int tn19;
int tn20;
int tn21;
int tn22;
int tn23;
int tn24;
int tn25;
int tn26;
int tn27;
int tn28;
int tn29;
int tn30;
int tn31;
int tn32;
int tn33;
int tn34;
};

struct RecordValues
{
int RecordId;
int tn1;
int tn2;
int tn3;
int tn4;
int tn5;
int tn6;
int tn7;
int tn8;
int tn9;
int tn10;
int tn11;
int tn12;
int tn13;
int tn14;
int tn15;
int tn16;
int tn17;
int tn18;
int tn19;
int tn20;
int tn21;
int tn22;
int tn23;
int tn24;
int tn25;
int tn26;
int tn27;
int tn28;
int tn29;
int tn30;
int tn31;
int tn32;
int tn33;
int tn34;
};

extern int Get_WinVer(void);
extern stringData * Get_SPVer(void);

extern BOOL COMAL_Debug(BOOL);
extern stringData * COMAL_GetErrorCode(void);
extern stringData * COMAL_GetErrorMsg(void);

extern BOOL DB_DisconnectFromAccess(void);
extern BOOL DB_ConnectToAccess(char *);
extern BOOL PWDB_ConnectToAccess(char *,char *);
extern void DB_GetRecord(int,struct RecordPointers *rpPtr);
extern int DB_GetAllRecords(char *,struct RecordTitles *rtPtr);
extern BOOL RECORD_Add(struct RecordTitles *rtPtr,struct RecordValues *rvPtr);
extern BOOL RECORD_Delete(void);
extern BOOL RECORD_MoveToFirst(void);
extern BOOL RECORD_MoveToLast(void);
extern BOOL RECORD_MoveUp(void);
extern BOOL RECORD_MoveDown(void);
extern BOOL RECORD_MoveTo(int);
extern BOOL RECORD_ChangeField(char *,char *);
extern int RECORDS_GetCount(void);
extern BOOL RECORDS_Open(char *);
extern BOOL RECORDS_Close(void);

DISPATCH_OBJ(conn);
DISPATCH_OBJ(rs);
DISPATCH_OBJ(crs);

OSVERSIONINFO osvi;
HWND ieWndw;
int rtn=0,record=0;
BOOL spchSts=FALSE,xlSts=FALSE,wSts=FALSE,adSts=FALSE,ieSts=FALSE,recSts=FALSE,recObj=FALSE;
char agentString[256];

int __declspec(dllexport) Get_WinVer(void)
{
osvi.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
if (GetVersionEx(&osvi))
{
if (osvi.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS)
{
if (osvi.dwMajorVersion==4)
{
if (osvi.dwMinorVersion==10)
{
if (osvi.dwBuildNumber==1998)
return 11; // Windows 98.
else if ((osvi.dwBuildNumber>1998) && (osvi.dwBuildNumber<2183))
return 12; // Windows 98 SP1.
else if (osvi.dwBuildNumber>2182)
return 13; // Windows 98SE.
}
else if (osvi.dwMinorVersion<10)
{
if (osvi.dwBuildNumber==950)
return 1; // Windows 95.
else if ((osvi.dwBuildNumber>950) && (osvi.dwBuildNumber<1081))
return 2; // Windows 95 SP1.
else if (osvi.dwBuildNumber>1080)
return 3; // Windows 95 R2.
}
else if (osvi.dwMinorVersion==90)
{
if (osvi.dwBuildNumber==3000)
return 21; // Windows ME.
}
}
}
else if (osvi.dwPlatformId==VER_PLATFORM_WIN32_NT)
{
if (osvi.dwMajorVersion==3)
{
if (osvi.dwMinorVersion==51)
{
if (osvi.dwBuildNumber==1057)
return 31; // Windows NT3.
}
}
else if (osvi.dwMajorVersion==4)
{
if (osvi.dwMinorVersion==0)
{
if (osvi.dwBuildNumber==1381)
return 41; // Windows NT 4.
}
}
else if (osvi.dwMajorVersion==5)
{
if (osvi.dwMinorVersion==0)
{
if (osvi.dwBuildNumber==2195)
return 51; // Windows 2000Pro.
}
else if (osvi.dwMinorVersion==1)
{
if (osvi.dwBuildNumber==2600)
return 61; // XP.
}
else if (osvi.dwMinorVersion==2)
{
return 71; // WinServer2003.
}
}
}
else if (osvi.dwPlatformId==VER_PLATFORM_WIN32_CE)
return 121; // Pocket Phone, Small Devices, etc.
}
return 0;
}

stringData * __declspec(dllexport) Get_SPVer(void)
{
if (Get_WinVer())
{
sprintf(sd.rtnStg,"%s",osvi.szCSDVersion);
return &sd;
}
return NULL;
}

char * UnicodeToAnsi(OLECHAR * szW)
{
static char szA[256];
szA[0]=0;
if (szW==NULL)
return "";
WideCharToMultiByte(CP_ACP,0,szW,-1,szA,256,NULL,NULL);
return szA;
}

BOOL __declspec(dllexport) COMAL_Debug(BOOL onoff)
{
HRESULT result;
result=dhToggleExceptions(onoff);
return result;
}

stringData * __declspec(dllexport) COMAL_GetErrorCode(void)
{
PDH_EXCEPTION pException=NULL;
dhGetLastException(&pException);
if (pException)
sprintf(sd.rtnStg,"%lx",pException->swCode);
else
sprintf(sd.rtnStg,"NO ERROR");
return &sd;
}

stringData * __declspec(dllexport) COMAL_GetErrorMsg(void)
{
PDH_EXCEPTION pException=NULL;
dhGetLastException(&pException);
if (pException)
sprintf(sd.rtnStg,"%ls",pException->szDescription);
else
sprintf(sd.rtnStg,"NO ERROR");
return &sd;
}

BOOL __declspec(dllexport) DB_DisconnectFromAccess(void)
{
int nState=0;
if (recSts==TRUE)
{
if (conn)
{
dhGetValue(L"%d",&nState,conn,L".State");
if (nState!=0)
dhCallMethod(conn,L".Close");
}
SAFE_RELEASE(rs);
SAFE_RELEASE(conn);
dhUninitialize(TRUE);
recSts=FALSE;
return TRUE;
}
return FALSE;
}

BOOL __declspec(dllexport) DB_ConnectToAccess(char *fname)
{
if (recSts==FALSE)
{
dhInitialize(TRUE);
char stgbuf[256];
strcpy(stgbuf,"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=");
strcat(stgbuf,fname);
strcat(stgbuf,";");
if (SUCCEEDED(dhCreateObject(L"ADODB.Connection",NULL,&conn)))
{
if (SUCCEEDED(dhCallMethod(conn,L".Open(%s)",stgbuf)))
{
recSts=TRUE;
return TRUE;
}
}
}
return FALSE;
}

BOOL __declspec(dllexport) PWDB_ConnectToAccess(char *fname,char *password)
{
if (recSts==FALSE)
{
dhInitialize(TRUE);
char stgbuf[256];
strcpy(stgbuf,"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=");
strcat(stgbuf,fname);
strcat(stgbuf,";Jet OLEDB:Database Password=");
strcat(stgbuf,password);
strcat(stgbuf,";");
if (SUCCEEDED(dhCreateObject(L"ADODB.Connection",NULL,&conn)))
{
if (SUCCEEDED(dhCallMethod(conn,L".Open(%s)",stgbuf)))
{
recSts=TRUE;
return TRUE;
}
}
}
return FALSE;
}

void __declspec(dllexport) DB_GetRecord(int number,struct RecordPointers *rpPtr)
{
if (recSts==TRUE)
{
rpPtr->id=rd[number].id;
rpPtr->title=(int)&rd[number].title;
rpPtr->first=(int)&rd[number].first;
rpPtr->middle=(int)&rd[number].middle;
rpPtr->last=(int)&rd[number].last;
rpPtr->suffix=(int)&rd[number].suffix;
rpPtr->birth=(int)&rd[number].birth;
rpPtr->age=(int)&rd[number].age;
rpPtr->sex=(int)&rd[number].sex;
rpPtr->nationality=(int)&rd[number].nationality;
rpPtr->culture=(int)&rd[number].culture;
rpPtr->languages=(int)&rd[number].languages;
rpPtr->years=(int)&rd[number].years;
rpPtr->hobbies=(int)&rd[number].hobbies;
rpPtr->building=(int)&rd[number].building;
rpPtr->street=(int)&rd[number].street;
rpPtr->area=(int)&rd[number].area;
rpPtr->town=(int)&rd[number].town;
rpPtr->city=(int)&rd[number].city;
rpPtr->pcode=(int)&rd[number].pcode;
rpPtr->country=(int)&rd[number].country;
rpPtr->home=(int)&rd[number].home;
rpPtr->mobile=(int)&rd[number].mobile;
rpPtr->work1=(int)&rd[number].work1;
rpPtr->work2=(int)&rd[number].work2;
rpPtr->ext1=(int)&rd[number].ext1;
rpPtr->ext2=(int)&rd[number].ext2;
rpPtr->fax1=(int)&rd[number].fax1;
rpPtr->fax2=(int)&rd[number].fax2;
rpPtr->web1=(int)&rd[number].web1;
rpPtr->web2=(int)&rd[number].web2;
rpPtr->email1=(int)&rd[number].email1;
rpPtr->email2=(int)&rd[number].email2;
rpPtr->notes=(int)&rd[number].notes;
rpPtr->endmarker=(int)&rd[number].endmarker;
}
}

int __declspec(dllexport) DB_GetAllRecords(char *tsname,struct RecordTitles *rtPtr)
{
BOOL bEOF;
int id=0;
char stgbuf[256],titles[100];
record=0;
if (recSts==TRUE)
{
sprintf(titles,"SELECT * FROM %s ORDER BY %s",tsname,(char *)rtPtr->RecordId);
if (SUCCEEDED(dhGetValue(L"%o",&rs,conn,L".Execute(%s)",titles)))
{
while (SUCCEEDED(dhGetValue(L"%b",&bEOF,rs,L".EOF")) && !bEOF)
{
LPSTR string1;
dhGetValue(L"%d",&id,rs,L".Fields(%s).Value",(char *)rtPtr->RecordId);
rd[record].id=id;
dhGetValue(L"%s",&string1,rs,L".Fields(%s).Value",(char *)rtPtr->tn1);
strcpy(rd[record].title,string1);
dhFreeString(string1);
LPSTR string2;
dhGetValue(L"%s",&string2,rs,L".Fields(%s).Value",(char *)rtPtr->tn2);
strcpy(rd[record].first,string2);
dhFreeString(string2);
LPSTR string3;
dhGetValue(L"%s",&string3,rs,L".Fields(%s).Value",(char *)rtPtr->tn3);
strcpy(rd[record].middle,string3);
dhFreeString(string3);
LPSTR string4;
dhGetValue(L"%s",&string4,rs,L".Fields(%s).Value",(char *)rtPtr->tn4);
strcpy(rd[record].last,string4);
dhFreeString(string4);
LPSTR string5;
dhGetValue(L"%s",&string5,rs,L".Fields(%s).Value",(char *)rtPtr->tn5);
strcpy(rd[record].suffix,string5);
dhFreeString(string5);
LPSTR string6;
dhGetValue(L"%s",&string6,rs,L".Fields(%s).Value",(char *)rtPtr->tn6);
strcpy(rd[record].birth,string6);
dhFreeString(string6);
LPSTR string7;
dhGetValue(L"%s",&string7,rs,L".Fields(%s).Value",(char *)rtPtr->tn7);
strcpy(rd[record].age,string7);
dhFreeString(string7);
LPSTR string8;
dhGetValue(L"%s",&string8,rs,L".Fields(%s).Value",(char *)rtPtr->tn8);
strcpy(rd[record].sex,string8);
dhFreeString(string8);
LPSTR string9;
dhGetValue(L"%s",&string9,rs,L".Fields(%s).Value",(char *)rtPtr->tn9);
strcpy(rd[record].nationality,string9);
dhFreeString(string9);
LPSTR string10;
dhGetValue(L"%s",&string10,rs,L".Fields(%s).Value",(char *)rtPtr->tn10);
strcpy(rd[record].culture,string10);
dhFreeString(string10);
LPSTR string11;
dhGetValue(L"%s",&string11,rs,L".Fields(%s).Value",(char *)rtPtr->tn11);
strcpy(rd[record].languages,string11);
dhFreeString(string11);
LPSTR string12;
dhGetValue(L"%s",&string12,rs,L".Fields(%s).Value",(char *)rtPtr->tn12);
strcpy(rd[record].years,string12);
dhFreeString(string12);
LPSTR string13;
dhGetValue(L"%s",&string13,rs,L".Fields(%s).Value",(char *)rtPtr->tn13);
strcpy(rd[record].hobbies,string13);
dhFreeString(string13);
LPSTR string14;
dhGetValue(L"%s",&string14,rs,L".Fields(%s).Value",(char *)rtPtr->tn14);
strcpy(rd[record].building,string14);
dhFreeString(string14);
LPSTR string15;
dhGetValue(L"%s",&string15,rs,L".Fields(%s).Value",(char *)rtPtr->tn15);
strcpy(rd[record].street,string15);
dhFreeString(string15);
LPSTR string16;
dhGetValue(L"%s",&string16,rs,L".Fields(%s).Value",(char *)rtPtr->tn16);
strcpy(rd[record].area,string16);
dhFreeString(string16);
LPSTR string17;
dhGetValue(L"%s",&string17,rs,L".Fields(%s).Value",(char *)rtPtr->tn17);
strcpy(rd[record].town,string17);
dhFreeString(string17);
LPSTR string18;
dhGetValue(L"%s",&string18,rs,L".Fields(%s).Value",(char *)rtPtr->tn18);
strcpy(rd[record].city,string18);
dhFreeString(string18);
LPSTR string19;
dhGetValue(L"%s",&string19,rs,L".Fields(%s).Value",(char *)rtPtr->tn19);
strcpy(rd[record].pcode,string19);
dhFreeString(string19);
LPSTR string20;
dhGetValue(L"%s",&string20,rs,L".Fields(%s).Value",(char *)rtPtr->tn20);
strcpy(rd[record].country,string20);
dhFreeString(string20);
LPSTR string21;
dhGetValue(L"%s",&string21,rs,L".Fields(%s).Value",(char *)rtPtr->tn21);
strcpy(rd[record].home,string21);
dhFreeString(string21);
LPSTR string22;
dhGetValue(L"%s",&string22,rs,L".Fields(%s).Value",(char *)rtPtr->tn22);
strcpy(rd[record].mobile,string22);
dhFreeString(string22);
LPSTR string23;
dhGetValue(L"%s",&string23,rs,L".Fields(%s).Value",(char *)rtPtr->tn23);
strcpy(rd[record].work1,string23);
dhFreeString(string23);
LPSTR string24;
dhGetValue(L"%s",&string24,rs,L".Fields(%s).Value",(char *)rtPtr->tn24);
strcpy(rd[record].work2,string24);
dhFreeString(string24);
LPSTR string25;
dhGetValue(L"%s",&string25,rs,L".Fields(%s).Value",(char *)rtPtr->tn25);
strcpy(rd[record].ext1,string25);
dhFreeString(string25);
LPSTR string26;
dhGetValue(L"%s",&string26,rs,L".Fields(%s).Value",(char *)rtPtr->tn26);
strcpy(rd[record].ext2,string26);
dhFreeString(string26);
LPSTR string27;
dhGetValue(L"%s",&string27,rs,L".Fields(%s).Value",(char *)rtPtr->tn27);
strcpy(rd[record].fax1,string27);
dhFreeString(string27);
LPSTR string28;
dhGetValue(L"%s",&string28,rs,L".Fields(%s).Value",(char *)rtPtr->tn28);
strcpy(rd[record].fax2,string28);
dhFreeString(string28);
LPSTR string29;
dhGetValue(L"%s",&string29,rs,L".Fields(%s).Value",(char *)rtPtr->tn29);
strcpy(rd[record].web1,string29);
dhFreeString(string29);
LPSTR string30;
dhGetValue(L"%s",&string30,rs,L".Fields(%s).Value",(char *)rtPtr->tn30);
strcpy(rd[record].web2,string30);
dhFreeString(string30);
LPSTR string31;
dhGetValue(L"%s",&string31,rs,L".Fields(%s).Value",(char *)rtPtr->tn31);
strcpy(rd[record].email1,string31);
dhFreeString(string31);
LPSTR string32;
dhGetValue(L"%s",&string32,rs,L".Fields(%s).Value",(char *)rtPtr->tn32);
strcpy(rd[record].email2,string32);
dhFreeString(string32);
LPSTR string33;
dhGetValue(L"%s",&string33,rs,L".Fields(%s).Value",(char *)rtPtr->tn33);
strcpy(rd[record].notes,string33);
dhFreeString(string33);
LPSTR string34;
dhGetValue(L"%s",&string34,rs,L".Fields(%s).Value",(char *)rtPtr->tn34);
strcpy(rd[record].endmarker,string34);
dhFreeString(string34);
dhCallMethod(rs,L".MoveNext");
record+=1;
}
}
return record;
}
return 0;
}

BOOL __declspec(dllexport) RECORD_Add(struct RecordTitles *rtPtr,struct RecordValues *rvPtr)
{
if (recObj==TRUE)
{
if (SUCCEEDED(dhCallMethod(crs,L".AddNew")))
{
dhPutValue(crs,L".Fields(%s).Value = %d",(char *)rtPtr->RecordId,rvPtr->RecordId);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn1,(char *)rvPtr->tn1);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn2,(char *)rvPtr->tn2);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn3,(char *)rvPtr->tn3);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn4,(char *)rvPtr->tn4);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn5,(char *)rvPtr->tn5);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn6,(char *)rvPtr->tn6);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn7,(char *)rvPtr->tn7);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn8,(char *)rvPtr->tn8);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn9,(char *)rvPtr->tn9);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn10,(char *)rvPtr->tn10);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn11,(char *)rvPtr->tn11);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn12,(char *)rvPtr->tn12);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn13,(char *)rvPtr->tn13);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn14,(char *)rvPtr->tn14);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn15,(char *)rvPtr->tn15);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn16,(char *)rvPtr->tn16);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn17,(char *)rvPtr->tn17);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn18,(char *)rvPtr->tn18);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn19,(char *)rvPtr->tn19);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn20,(char *)rvPtr->tn20);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn21,(char *)rvPtr->tn21);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn22,(char *)rvPtr->tn22);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn23,(char *)rvPtr->tn23);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn24,(char *)rvPtr->tn24);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn25,(char *)rvPtr->tn25);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn26,(char *)rvPtr->tn26);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn27,(char *)rvPtr->tn27);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn28,(char *)rvPtr->tn28);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn29,(char *)rvPtr->tn29);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn30,(char *)rvPtr->tn30);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn31,(char *)rvPtr->tn31);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn32,(char *)rvPtr->tn32);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn33,(char *)rvPtr->tn33);
dhPutValue(crs,L".Fields(%s).Value = %s",(char *)rtPtr->tn34,(char *)rvPtr->tn34);
dhCallMethod(crs,L".Update");
return TRUE;
}
}
return FALSE;
}

BOOL __declspec(dllexport) RECORD_Delete(void)
{
if (recObj==TRUE)
{
if (SUCCEEDED(dhCallMethod(crs,L".Delete")))
{
dhCallMethod(crs,L".UpdateBatch");
return TRUE;
}
}
return FALSE;
}

BOOL __declspec(dllexport) RECORD_MoveToFirst(void)
{
if (recObj==TRUE)
{
if (SUCCEEDED(dhCallMethod(crs,L".MoveFirst")))
return TRUE;
}
return FALSE;
}

BOOL __declspec(dllexport) RECORD_MoveToLast(void)
{
if (recObj==TRUE)
{
if (SUCCEEDED(dhCallMethod(crs,L".MoveLast")))
return TRUE;
}
return FALSE;
}

BOOL __declspec(dllexport) RECORD_MoveUp(void)
{
if (recObj==TRUE)
{
BOOL bBOF=FALSE;
if (SUCCEEDED(dhCallMethod(crs,L".MovePrevious")))
{
if (SUCCEEDED(dhGetValue(L"%b",&bBOF,crs,L".BOF")))
{
if (bBOF)
dhCallMethod(crs,L".MoveFirst");
return TRUE;
}
}
}
return FALSE;
}

BOOL __declspec(dllexport) RECORD_MoveDown(void)
{
if (recObj==TRUE)
{
BOOL bEOF=FALSE;
if (SUCCEEDED(dhCallMethod(crs,L".MoveNext")))
{
if (SUCCEEDED(dhGetValue(L"%b",&bEOF,crs,L".EOF")))
{
if (bEOF)
dhCallMethod(crs,L".MoveLast");
return TRUE;
}
}
}
return FALSE;
}

BOOL __declspec(dllexport) RECORD_MoveTo(int position)
{
if (recObj==TRUE)
{
BOOL bBOF=FALSE,bEOF=FALSE;
VARIANT bm;
if (SUCCEEDED(dhCallMethod(crs,L".Move(%d)",position)))
{
if (SUCCEEDED(dhGetValue(L"%v",&bm,crs,L".Bookmark")))
{
if (SUCCEEDED(dhGetValue(L"%b",&bBOF,crs,L".BOF")))
{
if (bBOF)
dhPutValue(crs,L".Bookmark = %v",bm);
}
if (SUCCEEDED(dhGetValue(L"%b",&bEOF,crs,L".EOF")))
{
if (bEOF)
dhPutValue(crs,L".Bookmark = %v",bm);
}
}
return TRUE;
}
}
return FALSE;
}

BOOL __declspec(dllexport) RECORD_ChangeField(char *field,char *value)
{
if (recObj==TRUE)
{
rtn=dhPutValue(crs,L".Fields(%s).Value = %s",field,value);
dhCallMethod(crs,L".Update");
if (SUCCEEDED(rtn))
return TRUE;
}
return FALSE;
}

int __declspec(dllexport) RECORDS_GetCount(void)
{
int count=0;
if (recObj==TRUE)
{
if (SUCCEEDED(dhGetValue(L"%d",&count,crs,L".RecordCount")))
return count;
}
return 0;
}

BOOL __declspec(dllexport) RECORDS_Close(void)
{
if (recObj==TRUE)
{
dhCallMethod(crs,L".Close");
SAFE_RELEASE(crs);
recObj=FALSE;
return TRUE;
}
return FALSE;
}

BOOL __declspec(dllexport) RECORDS_Open(char *tsname)
{
if (recSts==TRUE)
{
if (SUCCEEDED(dhCreateObject(L"ADODB.Recordset",NULL,&crs)))
{
if (SUCCEEDED(dhCallMethod(crs,L"Open(%s,%o,%d,%d)",tsname,conn,3,3)))
{
recObj=TRUE;
return TRUE;
}
}
}
return FALSE;
}

BOOL WINAPI __declspec(dllexport) LibMain(HINSTANCE hDLLInst,DWORD fdwReason,LPVOID lpvReserved)
{
switch (fdwReason)
{
case DLL_PROCESS_ATTACH:

break;
case DLL_PROCESS_DETACH:

break;
case DLL_THREAD_ATTACH:

break;
case DLL_THREAD_DETACH:

break;
}
return TRUE;
}
