' COMAL - COM Access Library. COMAL (Pronounced COM UL).
'
' ComalExcel.dll is a Dynamic Linked Library written by me,
' John White, for myself and any programming language that
' can utilize it.
'
' Website: http://www.yoingco.com/
'   Email: john@yoingco.com
'
' Tested   on:  Windows XP (SP2) Home Edition (Genuine).
'        with:  Microsoft Office Standard Edition 2003 (SP2) Trial (Genuine).
'        Date:  28th December 2006.

' To test the examples in this code you must first press the Excel Examples button.
' For example, to test the printer example you need to press Excel Example, then HyperLinks
' and then Printer.

nomainwin

global FALSE, TRUE, OFF, ONN, NO, YES
global xlrtn
global LANDSCAPE,PORTRAIT
global SCR.IMAGE,PRT.IMAGE
global BMP.FORMAT,PIC.FORMAT
global DAY,WEEKDAY,MONTH,YEAR
global AUTOFILL,LINEAR,CHRONOLOGICAL,GROWTH

FALSE=0
TRUE=1
OFF=0
ONN=1
NO=0
YES=1

' Printer Options
PORTRAIT=1
LANDSCAPE=2

' Image to Clipboard
SCR.IMAGE=1
PRT.IMAGE=2
BMP.FORMAT=2
PIC.FORMAT=-4147

' Data Series
DAY=1
WEEKDAY=2
MONTH=3
YEAR=4
AUTOFILL=4
LINEAR=-4132
CHRONOLOGICAL=3
GROWTH=2

' File Types
FT.WORD=1
FT.DOSText=2
FT.DOSTextLineBreak=3
FT.EncodedText=4
FT.HTML=5
FT.RTF=6
FT.Template=7
FT.Text=8
FT.TEXTLineBreak=9
FT.xlNormal=hexdec("&HFFFFEFD1")

xlrtn=FALSE

WindowWidth=680
WindowHeight=76
UpperLeftX=(DisplayWidth-WindowWidth)/2
UpperLeftY=(DisplayHeight-WindowHeight)/2

button #Form.B1, "Excel Example", [BC1], ul, 6, 6, 100, 30
button #Form.B2, "Print", [BC2], ul, 126, 6, 80, 30
button #Form.B3, "Save", [BC3], ul, 226, 6, 80, 30
button #Form.B4, "HyperLinks", [BC4], ul, 326, 6, 100, 30
button #Form.B5, "Printer", [BC5], ul, 454, 6, 80, 30
button #Form.B6, "Split Pane", [BC6], ul, 556, 6, 80, 30

stylebits #Form,0,0,_WS_EX_TOPMOST,0

open "COMAL - COM Access Library." for dialog as #Form
#Form "trapclose [quit.Form]"
open "comalexcel.dll" for dll as #comal
wait

[BC1]
xlrtn=XDocumentOpen(NO,NO,"")
if xlrtn=TRUE then

rtn=XSheetSetName("Business Accounts")
rtn=XSheetGetName()
'notice "Excel Sheet Name: "+winstring(rtn)

' Set the Format of a range
rtn=XCellSetFormat("",1,"B10:B12","@")       ' "@" = Text "hh:mm:ss" = Time)
rtn=XCellWriteText("",1,10,2,"Bread")
rtn=XCellWriteText("",1,11,2,"Milk")
rtn=XCellWriteText("",1,12,2,"Sugar")

' see the Format->Cells menu.
rtn=XCellSetColour("",1,"D3:E7",hexdec("&H000000FF"))
rtn=XCellSetBorderColour("",1,"D3:E7",hexdec("&H0000FFFF"))
' 1 to 13.
rtn=XCellSetBorderStyle("",1,"D3:E7",13)
' 1 to 4. See weight property->border->xlBorderWeight
rtn=XCellSetBorderThickness("",1,"D3:E7",4)
' 0 to 18.
rtn=XCellSetPattern("",1,"D3:E7",18)
' Set the Cell (Font / Column Height) Size.
rtn=XCellSetFontSize("",1,"D3:E7",44)

rtn=XCellWriteValue("",1,"B2:B4",23)
rtn=XCellWriteValue("",1,"B6",32)

rtn=XCellMergeCells("",1,"B15:E15")
rtn=XCellWriteMergedText("",1,"B15","This text is inside Merged Cells.")
' Range, lineStyle, Thickness, Colour.
rtn=XCellAddBorder("",1,"B15:E15",13,4,hexdec("&H00FF00FF"))

rtn=XCellSetColumnWidth("",1,"A:E",6.57)

vle=XCellReadValue("",1,"B2:B2")
'notice "Value of Cell B2: "+Str$(vle)

rtn=XCellReadText("",1,"B11")
'notice "Text of Cell B11: "+winstring(rtn)

' Clear the Bread/Milk/Sugar cells above.
'rtn=XCellClearRange("",1,"B10:B12")

rtn=XSheetActivate("",2)
rtn=XSheetSetName("Home Accounts")
rtn=XCellCopySourceToDest("Business Accounts",0,"B10:B12","Home Accounts",0,"A1:A3")

rtn=XSheetActivate("",1)
rtn=XSheetActivate("Sheet1",0)
rtn=XSheetActivate("Business Accounts",0)

rtn=XCellSelectRange("",1,"B10:B12")
rtn=XCellCopyRangeToClipboard("",1,"B10:B12")
rtn=XCellPasteRangeFromClipboard("Business Accounts",0,"D10:D12")
rtn=XCellPasteRangeFromClipboard("Business Accounts",0,"F10:F12")

' Fill cells B2 to B10 with the last cell's (B10's) value. FillDown would use B2's value.
'rtn=XSheetActivate("",3)
rtn=XCellWriteValue("",3,"B10",23)
rtn=XCellFillUp("Sheet3",0,"B2:B10")

' Fill cells B2 to M2 with the last cell's (M2's) value. FillRight would use A2's value.
'rtn=XSheetActivate("",3)
rtn=XCellWriteValue("",3,"M2",32)
rtn=XCellFillLeft("",3,"A2:M2")

rtn=XCellAddComment("",1,"B2","Hello. I would just like to make a really long comment about nothing at all.") ' Range must be 1 cell only
'rtn=XCellClearComments("",1,"B2:B10")

'rtn=XSheetActivate("",2)
rtn=XCellSetColumnWidth("",2,"A:D",2.57)
rtn=XCellAutoFitColumns("",2,"A:I")
'rtn=XCellAutoFitRange("",2,"A1:D1")

'rtn=XCellClearContents("",1,"A1:G16")

'rtn=XCellInsertCells("",1,"B:G")

' Scroll a window (worksheet) down, up, right or left.
'rtn=ExcelScrollWindow(0,1,0,0)

'rtn=XSheetPrintPreview("",1)

' Scrolls (place) the contents of a rectangular area into either the top-left corner (TRUE)
' or bottom-right corner (FALSE) of the window. x,y,width,height
'rtn=ExcelScrollWindowView(200,120,100,200,TRUE)

' Scrolls down/up columns and right/left rows. down,up,right,left
'rtn=ExcelScrollRowsColumns(12,0,0,0)

'rtn=XCellCopyAsPictureToClipboard("",1,"A1:H12",SCR.IMAGE,BMP.FORMAT)

rtn=XCellCalendarDays("",3,"B12:B23","B12","31-JAN-1996",1)

'rtn=XCellFunctionWizard()

'rtn=XCellSpeak("",3,"B12:B23")


'rtn=XDocumentClose()
'xlrtn=FALSE
end if
wait

[BC2]
'rtn=XSheetPrintActiveSheet()
' Print to a (.prn) File
'rtn=ExcelPrintAll(1,NO,"",YES,YES,"C:\\Test.prn")
' Print to a particular Printer
'rtn=ExcelPrintAll(1,NO,"EPSON Stylus C44 Series on NE01",NO,YES,"")
' Print to the Default printer
rtn=ExcelPrintAll(1,NO,"",NO,YES,"")
wait

[BC3]
rtn=XDocumentSave()
'rtn=XDocumentSaveAs("C:\Test.xls",FT.xlNormal)
if rtn=FALSE then
' File was Saved
end if
notice str$(rtn)
wait

[BC4]
' Note: All links must be valid (online or stored offline pages). They must also valid (actually
' exist as links in the cell/s you are using. If a cell is marked by MS Excel in a format that
' does not allow HyperLinks then these calls can fail (not put the HyperLink in that cell).
'
' Insert HyperLinks - SheetNumber will also be chosen over SheetName if sheetNumber>0
rtn=XSheetInsertHyperLink("Sheet3",0,"G5","http://www.google.com","Search Engine","Google")
rtn=XSheetInsertHyperLink("Sheet1",3,"G6","http://www.btyahoo.com","Check Your Email","BT Yahoo")
rtn=XSheetInsertHyperLink("Sheet3",0,"G7","http://www.grisoft.com","FREE Anti-Virus Software","AVG")

' Insert a MAILTO: (Email) HyperLink
rtn=XSheetInsertHyperLink("Sheet2",0,"G5","mailto:www.google.com?subject=Hello John","Also visit our Website","Email Me")

' Open a (offline or online) webpage.
' FALSE = Maximum Window. TRUE = custom (default/small) size.
'rtn=XSheetOpenHyperLink("http://www.btyahoo.com",FALSE)

' Activate (Open) the first (1) HyperLink on sheet 3 in the range B5 to B7.
' This opens B5 (www.google.com) in the above list.
'rtn=XSheetActivateHyperLink("Sheet3",0,"G5:G7",1)

rtn=XSheetGetHyperLinkName("Sheet1",3,"G5:G7",1)
notice WinString(rtn)
wait

[BC5]
' Select the printer's Print Area.
' This makes it possible to only print a certain area of a sheet.
rtn=XSheetSetPrintArea("Sheet3",0,"$B$4:$F$16") 'B4 to F16

' Reset the print area to maximum print area
'rtn=XSheetSetPrintArea("Sheet3",0,"")

' These alter some of the printer settings. In this example I will print (in BW, DRAFT mode
' using Landscape) the 3 HyperLinks from above.
rtn=XPrintSetOrientation("Sheet3",0,LANDSCAPE)
rtn=XPrintSetBW("Sheet3",0,TRUE)
rtn=XPrintSetDraft("Sheet3",0,TRUE)
rtn=XSheetPrintSheet("Sheet3",0)
wait

[BC6]
' Open (switch ONN) the Chart ToolBar
'rtn=ExcelToolBar("Chart",ONN)

' A window can be split into a Horizontal and/or Vertical Pane (Panel/Section). For example. If
' you set a horizontal pane, the top half of the sheet is always on screen as the bottom half
' of the sheet is scrolled. This is good when you want to see the top half of the sheet whilst
' you are checking (scrolling) further down the sheet. In this example the sheet keeps cells
' 1 to 10 in view whilst scrolling goes from cell 11 onwards - This is because I used
' XSheetFreezePanes() which freezes the top pane. If I did not use XSheetFreezePanes() then
' both panes would be scrollable. The same applies to Vertical panes.
rtn=XSheetActivate("Sheet3",0)
rtn=XSheetSplitRows(10)
'rtn=XSheetSplitColumns(192)
rtn=XSheetFreezePanes(TRUE)

rtn=XVIEWSetView(2)
wait

[quit.Form]
call CleanUpCOMAL
close #Form
close #comal
end

sub CleanUpCOMAL
if xlrtn=TRUE then
rtn=XDocumentClose()
xlrtn=FALSE
end if
end sub

function XDocumentClose()
calldll #comal,"XDOCUMENT_Close",XDocumentClose as Long
end function

function XDocumentSave()
calldll #comal,"XDOCUMENT_Save",XDocumentSave as Long
end function

function XDocumentSaveAs(fileName$,fileType)
calldll #comal,"XDOCUMENT_SaveAs",fileName$ as ptr,fileType as long,XDocumentSaveAs as Long
end function

function XDocumentOpen(fullScreen,useFile,fileName$)
calldll #comal,"XDOCUMENT_Open",fullScreen as long,useFile as long,fileName$ as ptr,XDocumentOpen as long
end function

function XSheetActivate(sheetName$,sheetNumber)
calldll #comal,"XSHEET_Activate",sheetName$ as ptr,sheetNumber as long,XSheetActivate as long
end function

function XSheetSetName(sheetName$)
calldll #comal,"XSHEET_SetName",sheetName$ as ptr,XSheetSetName as long
end function

function XSheetGetName()
calldll #comal,"XSHEET_GetName",XSheetGetName as long
end function

function XSheetInsertHyperLink(sheetName$,sheetNumber,range$,link$,screenTip$,title$)
calldll #comal,"XSHEET_InsertHyperLink",sheetName$ as ptr,sheetNumber as long,range$ as ptr,link$ as ptr,screenTip$ as ptr,title$ as ptr,XSheetInsertHyperLink as long
end function

function XSheetOpenHyperLink(link$,openNewWindow)
calldll #comal,"XSHEET_OpenHyperLink",link$ as ptr,openNewWindow as long,XSheetOpenHyperLink as long
end function

function XSheetActivateHyperLink(sheetName$,sheetNumber,range$,index)
calldll #comal,"XSHEET_ActivateHyperLink",sheetName$ as ptr,sheetNumber as long,range$ as ptr,index as long,XSheetActivateHyperLink as long
end function

function XSheetGetHyperLinkName(sheetName$,sheetNumber,range$,index)
calldll #comal,"XSHEET_GetHyperLinkName",sheetName$ as ptr,sheetNumber as long,range$ as ptr,index as long,XSheetGetHyperLinkName as long
end function

function XSheetPrintSheet(sheetName$,sheetNumber)
calldll #comal,"XSHEET_PrintSheet",sheetName$ as ptr,sheetNumber as long,XSheetPrintSheet as long
end function

function XSheetPrintSheetEx(sheetName$,sheetNumber,copies,preview,printerName$,printToFile,collate,ptfName$)
calldll #comal,"XSHEET_PrintSheetEx",sheetName$ as ptr,sheetNumber as long,copies as long,preview as long,printerName$ as ptr,printToFile as long,collate as long,ptfName$ as ptr,XSheetPrintSheet as long
end function

function XSheetPrintPreview(sheetName$,sheetNumber)
calldll #comal,"XSHEET_PrintPreview",sheetName$ as ptr,sheetNumber as long,XSheetPrintPreview as long
end function

function XSheetSetPrintArea(sheetName$,sheetNumber,range$)
calldll #comal,"XSHEET_SetPrintArea",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XSheetSetPrintArea as long
end function

function XSheetSplitRows(height)
calldll #comal,"XSHEET_SplitRows",height as long,XSheetSplitRows as long
end function

function XSheetSplitColumns(width)
calldll #comal,"XSHEET_SplitColumns",width as long,XSheetSplitColumns as long
end function

function XSheetFreezePanes(onoff)
calldll #comal,"XSHEET_FreezePanes",onoff as long,XSheetFreezePanes as long
end function

function ExcelFullScreen(yesno)
calldll #comal,"EXCEL_FullScreen",yesno as long,ExcelFullScreen as long
end function

function ExcelVisible(yesno)
calldll #comal,"EXCEL_Visible",yesno as long,ExcelVisible as long
end function

function ExcelPrintAll(copies,preview,printerName$,printToFile,collate,ptfName$)
calldll #comal,"EXCEL_PrintAll",copies as long,preview as long,printerName$ as ptr,printToFile as long,collate as long,ptfName$ as ptr,ExcelPrintAll as long
end function

function ExcelPrintSheetEx(sheetName$,sheetNumber,copies,preview,printerName$,printToFile,collate,ptfName$)
calldll #comal,"EXCEL_PrintSheetEx",sheetName$ as ptr,sheetNumber as long,copies as long,preview as long,printerName$ as ptr,printToFile as long,collate as long,ptfName$ as ptr,ExcelPrintSheetEx as long
end function

function ExcelToolBar(barName$,visible)
calldll #comal,"EXCEL_ToolBar",barName$ as ptr,visible as long,ExcelToolBar as long
end function

function ExcelScrollWindow(down,up,right,left)
calldll #comal,"EXCEL_ScrollWindow",down as long,up as long,right as long,left as long,ExcelScrollWindow as long
end function

function ExcelScrollRowsColumns(down,up,right,left)
calldll #comal,"EXCEL_ScrollRowsColumns",down as long,up as long,right as long,left as long,ExcelScrollRowsColumns as long
end function

function ExcelScrollWindowView(x,y,width,height,position)
calldll #comal,"EXCEL_ScrollWindowView",x as long,y as long,width as long,height as long,position as long,ExcelScrollWindowView as long
end function

function XPrintSetOrientation(sheetName$,sheetNumber,direction)
calldll #comal,"XPRINT_SetOrientation",sheetName$ as ptr,sheetNumber as long,direction as long,XPrintSetOrientation as long
end function

function XPrintSetBW(sheetName$,sheetNumber,onoff)
calldll #comal,"XPRINT_SetBW",sheetName$ as ptr,sheetNumber as long,onoff as long,XPrintSetBW as long
end function

function XPrintSetDraft(sheetName$,sheetNumber,onoff)
calldll #comal,"XPRINT_SetDraft",sheetName$ as ptr,sheetNumber as long,onoff as long,XPrintSetDraft as long
end function

function XPrintSetFirstPageNumber(sheetName$,sheetNumber,pageNumber)
calldll #comal,"XPRINT_SetFirstPageNumber",sheetName$ as ptr,sheetNumber as long,pageNumber as long,XPrintSetFirstPageNumber as long
end function

function XCellWriteText(sheetName$,sheetNumber,numberCoord,letterCoord,textString$)
calldll #comal,"XCELL_WriteText",sheetName$ as ptr,sheetNumber as long,numberCoord as long,letterCoord as long,textString$ as ptr,XCellWriteText as long
end function

function XCellSetColour(sheetName$,sheetNumber,range$,colour)
calldll #comal,"XCELL_SetColour",sheetName$ as ptr,sheetNumber as long,range$ as ptr,colour as long,XCellSetColour as long
end function

function XCellSetPattern(sheetName$,sheetNumber,range$,colour)
calldll #comal,"XCELL_SetPattern",sheetName$ as ptr,sheetNumber as long,range$ as ptr,colour as long,XCellSetPattern as long
end function

function XCellSetBorderColour(sheetName$,sheetNumber,range$,colour)
calldll #comal,"XCELL_SetBorderColour",sheetName$ as ptr,sheetNumber as long,range$ as ptr,colour as long,XCellSetBorderColour as long
end function

function XCellSetBorderStyle(sheetName$,sheetNumber,range$,style)
calldll #comal,"XCELL_SetBorderStyle",sheetName$ as ptr,sheetNumber as long,range$ as ptr,style as long,XCellSetBorderStyle as long
end function

function XCellSetBorderThickness(sheetName$,sheetNumber,range$,thickness)
calldll #comal,"XCELL_SetBorderThickness",sheetName$ as ptr,sheetNumber as long,range$ as ptr,thickness as long,XCellSetBorderThickness as long
end function

function XCellSetFontSize(sheetName$,sheetNumber,range$,fontSize)
calldll #comal,"XCELL_SetFontSize",sheetName$ as ptr,sheetNumber as long,range$ as ptr,fontSize as long,XCellSetFontSize as long
end function

function XCellSetFormat(sheetName$,sheetNumber,range$,nformat$)
calldll #comal,"XCELL_SetFormat",sheetName$ as ptr,sheetNumber as long,range$ as ptr,nformat$ as ptr,XCellSetFormat as long
end function

function XCellWriteValue(sheetName$,sheetNumber,range$,value)
calldll #comal,"XCELL_WriteValue",sheetName$ as ptr,sheetNumber as long,range$ as ptr,value as long,XCellWriteValue as long
end function

function XCellReadText(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_ReadText",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellReadText as long
end function

function XCellReadValue(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_ReadValue",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellReadValue as double
end function

function XCellMergeCells(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_MergeCells",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellMergeCells as long
end function

function XCellWriteMergedText(sheetName$,sheetNumber,range$,mergedText$)
calldll #comal,"XCELL_WriteMergedText",sheetName$ as ptr,sheetNumber as long,range$ as ptr,mergedText$ as ptr,XCellWriteMergedText as long
end function

function XCellAddBorder(sheetName$,sheetNumber,range$,lineStyle,thickness,colour)
calldll #comal,"XCELL_AddBorder",sheetName$ as ptr,sheetNumber as long,range$ as ptr,lineStyle as long,thickness as long,colour as long,XCellAddBorder as long
end function

function XCellSetColumnWidth(sheetName$,sheetNumber,range$,columnWidth)
calldll #comal,"XCELL_SetColumnWidth",sheetName$ as ptr,sheetNumber as long,range$ as ptr,columnWidth as double,XCellSetColumnWidth as long
end function

function XCellSetRowHeight(sheetName$,sheetNumber,range$,rowHeight)
calldll #comal,"XCELL_SetRowHeight",sheetName$ as ptr,sheetNumber as long,range$ as ptr,rowHeight as double,XCellSetRowHeight as long
end function

function XCellSelectRange(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_SelectRange",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellSelectRange as long
end function

function XCellClearRange(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_ClearRange",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellClearRange as long
end function

function XCellCopyRangeToClipboard(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_CopyRangeToClipboard",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellCopyRangeToClipboard as long
end function

function XCellCutRangeToClipboard(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_CutRangeToClipboard",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellCutRangeToClipboard as long
end function

function XCellPasteRangeFromClipboard(destSheet$,dSheetNumber,destRange$)
calldll #comal,"XCELL_PasteRangeFromClipboard",destSheet$ as ptr,dSheetNumber as long,destRange$ as ptr,XCellPasteRangeFromClipboard as long
end function

function XCellCopySourceToDest(sourceSheet$,sSheetNumber,sourceRange$,destSheet$,dSheetNumber,destRange$)
calldll #comal,"XCELL_CopySourceToDest",sourceSheet$ as ptr,sSheetNumber as long,sourceRange$ as ptr,destSheet$ as ptr,dSheetNumber as long,destRange$ as ptr,XCellCopySourceToDest as long
end function

function XCellFunction(digitsReturned,funcName,sourceSheet$,sourceRange$,destSheet$,destRange$,thirdSheet$,thirdRange$,number,textString$)
calldll #comal,"XCELL_Function",digitsReturned as long,funcName as long,sourceSheet$ as ptr,sourceRange$ as ptr,destSheet$ as ptr,destRange$ as ptr,thirdSheet$ as ptr,thirdRange$ as ptr,number as long,textString$ as ptr,XCellFunction as long
end function

' Fill functions allow you to fill a range based on the value of a certain cell in that range.
function XCellFillUp(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_FillUp",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellFillUp as long
end function

function XCellFillDown(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_FillDown",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellFillDown as long
end function

function XCellFillLeft(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_FillLeft",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellFillLeft as long
end function

function XCellFillRight(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_FillRight",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellFillRight as long
end function

' Add comments to a cell.
function XCellAddComment(sheetName$,sheetNumber,range$,comment$)
calldll #comal,"XCELL_AddComment",sheetName$ as ptr,sheetNumber as long,range$ as ptr,comment$ as ptr,XCellAddComment as long
end function

' Clear comments from a range.
function XCellClearComments(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_ClearComments",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellClearComments as long
end function

' Automatically adjust the width of each colummn based on the range (A:M) for example.
function XCellAutoFitColumns(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_AutoFitColumns",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellAutoFitColumns as long
end function

' Automatically adjust the width of each colummn based on the contents of range (A1:M1) for example.
function XCellAutoFitRange(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_AutoFitRange",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellAutoFitRange as long
end function

' Clear the contents (Text only) of range, but leave its formatting in place.
function XCellClearContents(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_ClearContents",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellClearContents as long
end function

' Clear the formatting from a range of cells.
function XCellClearFormatting(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_ClearFormatting",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellClearFormatting as long
end function

function XCellClearOutline(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_ClearOutline",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellClearOutline as long
end function

function XCellInsertCells(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_InsertCells",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellInsertCells as long
end function

function XCellCopyAsPictureToClipboard(sheetName$,sheetNumber,range$,appearance,format)
calldll #comal,"XCELL_CopyAsPictureToClipboard",sheetName$ as ptr,sheetNumber as long,range$ as ptr,appearance as long,format as long,XCellCopyAsPictureToClipboard as long
end function

function XCellFormula(sheetName$,sheetNumber,range$,formula$)
calldll #comal,"XCELL_Formula",sheetName$ as ptr,sheetNumber as long,range$ as ptr,formula$ as ptr,XCellFormula as long
end function

function XCellCalendarDays(sheetName$,sheetNumber,destRange$,sourceRange$,formula$,steps)
calldll #comal,"XCELL_CalendarDays",sheetName$ as ptr,sheetNumber as long,destRange$ as ptr,sourceRange$ as ptr,formula$ as ptr,steps as long,XCellCalendarDays as long
end function

function XCellFunctionWizard()
calldll #comal,"XCELL_FunctionWizard",XCellFunctionWizard as long
end function

function XCellSpeak(sheetName$,sheetNumber,range$)
calldll #comal,"XCELL_Speak",sheetName$ as ptr,sheetNumber as long,range$ as ptr,XCellSpeak as long
end function

function XVIEWSetView(view)
calldll #comal,"XVIEW_SetView",view as long,XVIEWSetView as long
end function

