' wmiinfo.dll is a Dynamic Linked Library written by me,
' John White, for myself and any programming language that
' can utilize it.
'
' Purpose: To retreive WMI (BIOS, CPU, BUS, DESKTOP, HOTFIXES, INSTALLED PRODUCTS, INSTALLED SERVICES, OS, Etc) Informaton.
'
' Here is the current link for WMI Classes. Each WMI Class is explained together with what result to expect from a certain
' class's field/property.
'
' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/wmisdk/wmi/win32_classes.asp
'
' My Website: http://www.yoingco.com/
'   My Email: john@yoingco.com
'
' Tested   on:  Windows XP (SP2) Home Edition (Genuine).
'        Date:  Saturday 4th November 2006.

struct BIOSInfo, _
smMajorVersion as long, _
smMinorVersion as long, _
primaryBIOS as long, _
softwareElementState as long, _
targetOS as long, _
caption as long, _
description as long, _
manufacturer as long, _
nname as long, _
serialNumber as long, _
status as long, _
version as long, _
smVersion as long

struct CPUInfo, _
currentClockSpeed as long, _
maxClockSpeed as long, _
addressWidth as long, _
architecture as long, _
availability as long, _
cpuStatus as long, _
dataWidth as long, _
extClock as long, _
family as long, _
level as long, _
loadPercentage as long, _
processorType as long, _
revision as long, _
statusInfo as long, _
upgradeMethod as long, _
caption as long, _
deviceID as long, _
manufacturer as long, _
nname as long, _
otherFamilyDescription as long, _
role as long, _
socketDesignation as long, _
status as long, _
stepping as long, _
version as long

struct BUSInfo, _
availability as long, _
busNumber as long, _
busType as long, _
statusInfo as long, _
caption as long, _
description as long, _
deviceID as long, _
nname as long, _
pnpDeviceID as long, _
status as long

struct DTInfo, _
borderWidth as long, _
coolSwitch as long, _
cursorBlinkRate as long, _
dragFullWindows as long, _
gridGranularity as long, _
iconSpacing as long, _
iconTitleSize as long, _
iconTitleWrap as long, _
screenSaverActive as long, _
screenSaverSecure as long, _
screenSaverTimeout as long, _
wallpaperStretched as long, _
wallpaperTiled as long, _
caption as long, _
description as long, _
iconTitleFaceName as long, _
nname as long, _
pattern as long, _
screenSaverExecutable as long, _
settingID as long, _
wallpaper as long

struct HOTFIXESInfo, _
description as long, _
fixComments as long, _
hotFixID as long, _
installedBy as long, _
installedOn as long, _
servicePackInEffect as long

struct ISInfo, _
installState as long, _
caption as long, _
description as long, _
identifyingNumber as long, _
installDate as long, _
installLocation as long, _
nname as long, _
packageCache as long, _
skuNumber as long, _
vendor as long, _
version as long

struct SSInfo, _
acceptPause as long, _
acceptStop as long, _
desktopInteract as long, _
processID as long, _
started as long, _
waitHint as long, _
caption as long, _
description as long, _
displayName as long, _
nname as long, _
pathName as long, _
serviceType as long, _
startMode as long, _
startName as long, _
state as long, _
status as long

struct NWAInfo, _
adapterTypeID as long, _
autoSense as long, _
availability as long, _
index as long, _
installed as long, _
maxNumberControlled as long, _
netConnectionStaus as long, _
powerManagementSupported as long, _
statusInfo as long, _
adapterType as long, _
caption as long, _
description as long, _
deviceID as long, _
macAddress as long, _
manufacturer as long, _
netConnectionID as long, _
pnpDeviceID as long, _
productName as long, _
serviceName as long

struct OSInfo, _
currentTimeZone as long, _
numberOfUsers as long, _
osLanguage as long, _
osType as long, _
primary as long, _
spMajorVersion as long, _
spMinorVersion as long, _
bootDevice as long, _
buildNumber as long, _
buildType as long, _
caption as long, _
codeSet as long, _
countryCode as long, _
description as long, _
locale as long, _
manufacturer as long, _
nname as long, _
organization as long, _
registeredUser as long, _
serialNumber as long, _
status as long, _
systemDevice as long, _
systemDirectory as long, _
systemDrive as long, _
version as long, _
windowsDirectory as long

struct UAInfo, _
accountType as long, _
disabled as long, _
localAccount as long, _
lockout as long, _
passwordChangable as long, _
passwordExpires as long, _
passwordRequired as long, _
sidType as long, _
caption as long, _
description as long, _
domain as long, _
fullName as long, _
nname as long, _
sid as long, _
status as long

struct VIDEOInfo, _
adapterRAM as long, _
availability as long, _
colorTableEntries as long, _
currentBitsPerPixel as long, _
currentHorizontalResolution as long, _
currentNumberOfColumns as long, _
currentNumberOfRows as long, _
currentRefreshRate as long, _
currentScanMode as long, _
currentVerticalResolution as long, _
deviceSpecificPens as long, _
ditherType as long, _
icmIntent as long, _
icmMethod as long, _
maxMemorySupported as long, _
maxNumberControlled as long, _
maxRefreshRate as long, _
minRefreshRate as long, _
monochrome as long, _
numberOfColorPlanes as long, _
numberOfVideoPages as long, _
protocolSupported as long, _
reservedSystemPaletteEntries as long, _
specificationVersion as long, _
statusInfo as long, _
systemPaletteEntries as long, _
videoArchitecture as long, _
videoMemoryType as long, _
videoMode as long, _
adapterCompatibility as long, _
adapterDACType as long, _
compatibilityDescriptions as long, _
caption as long, _
description as long, _
deviceID as long, _
driverVersion as long, _
infFilename as long, _
infSection as long, _
installedDisplayDrivers as long, _
nname as long, _
pnpDeviceID as long, _
status as long, _
videoModeDescription as long, _
videoProcessor as long

global FALSE,TRUE
global rtn

FALSE=0
TRUE=1

open "wmiinfo.dll" for dll as #wmidll

print "********** BIOS Info **********"
print ""
rtn=GetBIOSInfo()
print ""
if BIOSInfo.primaryBIOS.struct=FALSE then
print "Primary BIOS: NO"
else
print "Primary BIOS: YES"
end if
print "Caption: "+winstring(BIOSInfo.caption.struct)
print "Description: "+winstring(BIOSInfo.description.struct)
print "Manufacturer: "+winstring(BIOSInfo.manufacturer.struct)
print "Name: "+winstring(BIOSInfo.nname.struct)
print "Serial Number: "+winstring(BIOSInfo.serialNumber.struct)
print "Status: "+winstring(BIOSInfo.status.struct)
print "Version: "+winstring(BIOSInfo.version.struct)
if winstring(BIOSInfo.smVersion.struct)<>"Not Supported" then
print "SMBIOS Version: "+winstring(BIOSInfo.smVersion.struct)
print "SMBIOS Major Version: "+str$(BIOSInfo.smMajorVersion.struct)
print "SMBIOS Minor Version: "+str$(BIOSInfo.smMinorVersion.struct)
end if
print "Software Element State: "+str$(BIOSInfo.softwareElementState.struct)
print "Target Operating System: "+str$(BIOSInfo.targetOS.struct)
print ""
print ""


print "********** CPU Info **********"
print ""
rtn=GetCPUInfo()
print ""
print "Address Width: "+str$(CPUInfo.addressWidth.struct)
print "Architecture: "+str$(CPUInfo.architecture.struct)
print "Availability: "+str$(CPUInfo.availability.struct)
print "Current Clock Speed: "+str$(CPUInfo.currentClockSpeed.struct)
print "CPU Status: "+str$(CPUInfo.cpuStatus.struct)
print "Data Width: "+str$(CPUInfo.dataWidth.struct)
print "External Clock Frequency: "+str$(CPUInfo.extClock.struct)
print "Family: "+str$(CPUInfo.family.struct)
print "Level: "+str$(CPUInfo.level.struct)
print "Load Percentage: "+str$(CPUInfo.loadPercentage.struct)
print "Maximum Clock Speed: "+str$(CPUInfo.maxClockSpeed.struct)
print "Processor Type: "+str$(CPUInfo.processorType.struct)
print "Revision: "+str$(CPUInfo.revision.struct)
print "Staus Info: "+str$(CPUInfo.statusInfo.struct)
print "Upgrade Method: "+str$(CPUInfo.upgradeMethod.struct)
print ""
print "Caption: "+winstring(CPUInfo.caption.struct)
print "DeviceID: "+winstring(CPUInfo.deviceID.struct)
print "Manufacturer: "+winstring(CPUInfo.manufacturer.struct)
print "Name: "+winstring(CPUInfo.nname.struct)
print "Other Family Description: "+winstring(CPUInfo.otherFamilyDescription.struct)
print "Role: "+winstring(CPUInfo.role.struct)
print "Socket Designation: "+winstring(CPUInfo.socketDesignation.struct)
print "Status: "+winstring(CPUInfo.status.struct)
print "Stepping: "+winstring(CPUInfo.stepping.struct)
print "Version: "+winstring(CPUInfo.version.struct)
print ""
print ""


print "********** OPERATING SYSTEM Info **********"
print ""
rtn=GetOSInfo()
print ""
print "Current Time Zone: "+str$(OSInfo.currentTimeZone.struct)    ' Will be 60 if 1 hour daylight saving time is on.
print "Number Of Users: "+str$(OSInfo.numberOfUsers.struct)        ' 2 = You and the Administrator.
print "OS Language: "+str$(OSInfo.osLanguage.struct)
print "OS Type: "+str$(OSInfo.osType.struct)
if OSInfo.primary.struct=FALSE then
print "Pimary OS: NO"
else
print "Pimary OS: YES"
end if
print "Service Pack Major Version: "+str$(OSInfo.spMajorVersion.struct)
print "Service Pack Minor Version: "+str$(OSInfo.spMinorVersion.struct)
print "Boot Device: "+winstring(OSInfo.bootDevice.struct)
print "Build Number: "+winstring(OSInfo.buildNumber.struct)
print "Build Type: "+winstring(OSInfo.buildType.struct)
print "Caption: "+winstring(OSInfo.caption.struct)
print "Code Set: "+winstring(OSInfo.codeSet.struct)
print "Country Code: "+winstring(OSInfo.countryCode.struct)
print "Description: "+winstring(OSInfo.description.struct)
print "Locale: "+winstring(OSInfo.locale.struct)
print "Manufacturer: "+winstring(OSInfo.manufacturer.struct)
print "Name: "+winstring(OSInfo.nname.struct)
print "Organization: "+winstring(OSInfo.organization.struct)
print "Registered User: "+winstring(OSInfo.registeredUser.struct)
print "Serial Number: "+winstring(OSInfo.serialNumber.struct)
print "Status: "+winstring(OSInfo.status.struct)
print "System Device: "+winstring(OSInfo.systemDevice.struct)
print "System Directory: "+winstring(OSInfo.systemDirectory.struct)
print "System Drive: "+winstring(OSInfo.systemDrive.struct)
print "Version: "+winstring(OSInfo.version.struct)
print "Windows Directory: "+winstring(OSInfo.windowsDirectory.struct)
print ""
print ""


' Note: Not all HOTFIX UPDATE fields fill in their information, especially if the are pre-SP3.
print "********** HOTFIXES Info **********"
print ""
rtn=GetHOTFIXESData()
print "#Hotfix Updates: ";str$(rtn)
print ""
for number=0 to rtn-1
rtn=GetHOTFIXESInfo(number)
print "Description: "+winstring(HOTFIXESInfo.description.struct)
print "Fix Comments: "+winstring(HOTFIXESInfo.fixComments.struct)
print "Hotfix ID: "+winstring(HOTFIXESInfo.hotFixID.struct)
print "Installed By: "+winstring(HOTFIXESInfo.installedBy.struct)
print "Installed On: "+winstring(HOTFIXESInfo.installedOn.struct)
print "Service Pack In Effect: "+winstring(HOTFIXESInfo.servicePackInEffect.struct)
print ""
next
print ""
print ""


' Note: Not all NETWORK ADAPTER fields fill in their information - They can leave (null)
print "********** Network Adapters (NWA) Info **********"
print ""
rtn=GetNWAData()
print "#Network Adapters: ";str$(rtn)
print ""
for number=0 to rtn-1
rtn=GetNWAInfo(number)
print "Adapter Type ID: "+str$(NWAInfo.adapterTypeID.struct)
print "Auto Sense: "+str$(NWAInfo.autoSense.struct)
print "Availability: "+str$(NWAInfo.availability.struct)
print "Index: "+str$(NWAInfo.index.struct)
print "Installed: "+str$(NWAInfo.installed.struct)
print "Maximum Number Controlled: "+str$(NWAInfo.maxNumberControlled.struct)
print "Net Connection Staus: "+str$(NWAInfo.netConnectionStaus.struct)
print "Power Management Supported?: "+str$(NWAInfo.powerManagementSupported.struct)
print "Status Info: "+str$(NWAInfo.statusInfo.struct)
print "Adapter Type: "+winstring(NWAInfo.adapterType.struct)
print "Caption: "+winstring(NWAInfo.caption.struct)
print "Description: "+winstring(NWAInfo.description.struct)
print "Device ID: "+winstring(NWAInfo.deviceID.struct)
print "MAC Address: "+winstring(NWAInfo.macAddress.struct)
print "Manufacturer: "+winstring(NWAInfo.manufacturer.struct)
print "Net Connection ID: "+winstring(NWAInfo.netConnectionID.struct)
print "PnP Device ID: "+winstring(NWAInfo.pnpDeviceID.struct)
print "Product Name: "+winstring(NWAInfo.productName.struct)
print "Service Name: "+winstring(NWAInfo.serviceName.struct)
print ""
print ""
next


' Note: Not all USER ACCOUNT fields fill in their information - They can leave a Space.
print "********** User Account Info **********"
print ""
rtn=GetUAData()
print "#User Accounts: ";str$(rtn)
print ""
for number=0 to rtn-1
rtn=GetUAInfo(number)
print "Account Type: "+str$(UAInfo.accountType.struct)
print "Disabled: "+str$(UAInfo.disabled.struct)
print "Local Account: "+str$(UAInfo.localAccount.struct)
print "Lockout: "+str$(UAInfo.lockout.struct)
print "Password Changable: "+str$(UAInfo.passwordChangable.struct)
print "Password Expires: "+str$(UAInfo.passwordExpires.struct)
print "Password Required: "+str$(UAInfo.passwordRequired.struct)
print "SID Type: "+str$(UAInfo.sidType.struct)
print "Caption: "+winstring(UAInfo.caption.struct)
print "Description: "+winstring(UAInfo.description.struct)
print "Domain: "+winstring(UAInfo.domain.struct)
print "Full Name: "+winstring(UAInfo.fullName.struct)
print "Name: "+winstring(UAInfo.nname.struct)
print "SID: "+winstring(UAInfo.sid.struct)
print "Status: "+winstring(UAInfo.status.struct)
print ""
print ""
next


' Note: Not all BUS fields fill in their information - They can leave (null)
print "********** BUS Info **********"
print ""
rtn=GetBUSData()
print "#Buses: ";str$(rtn)
print ""
for number=0 to rtn-1
rtn=GetBUSInfo(number)
print "Availability: "+str$(BUSInfo.availability.struct)
print "Bus Number: "+str$(BUSInfo.busNumber.struct)
print "Bus Type: "+str$(BUSInfo.busType.struct)
print "Status Info: "+str$(BUSInfo.statusInfo.struct)
print "Caption: "+winstring(BUSInfo.caption.struct)
print "Description: "+winstring(BUSInfo.description.struct)
print "Device ID: "+winstring(BUSInfo.deviceID.struct)
print "Name: "+winstring(BUSInfo.nname.struct)
print "Status: "+winstring(BUSInfo.status.struct)
print ""
next
print ""
print ""


' Note: Not all DESKTOP fields fill in their information - They can leave (null)
print "********** DESKTOP Info **********"
print ""
rtn=GetDTData()
print "#Desktops: ";str$(rtn)
print ""
for number=0 to rtn-1
rtn=GetDTInfo(number)
print "Border Width: "+str$(DTInfo.borderWidth.struct)
print "Cool Switch: "+str$(DTInfo.coolSwitch.struct)
print "Cursor Blink Rate: "+str$(DTInfo.cursorBlinkRate.struct)
print "Drag Full Windows: "+str$(DTInfo.dragFullWindows.struct)
print "Grid Granularity: "+str$(DTInfo.gridGranularity.struct)
print "Icon Spacing: "+str$(DTInfo.iconSpacing.struct)
print "Icon Title Size: "+str$(DTInfo.iconTitleSize.struct)
print "Icon Title Wrap: "+str$(DTInfo.iconTitleWrap.struct)
print "Screen Saver Active: "+str$(DTInfo.screenSaverActive.struct)
print "Screen Saver Secure: "+str$(DTInfo.screenSaverSecure.struct)
print "Screen Saver Timeout: "+str$(DTInfo.screenSaverTimeout.struct)
print "Wallpaper Stretched: "+str$(DTInfo.wallpaperStretched.struct)
print "Wallpaper Tiled: "+str$(DTInfo.wallpaperTiled.struct)
print "Caption: "+winstring(DTInfo.caption.struct)
print "Description: "+winstring(DTInfo.description.struct)
print "Icon Title Face Name: "+winstring(DTInfo.iconTitleFaceName.struct)
print "Name: "+winstring(DTInfo.nname.struct)
print "Pattern: "+winstring(DTInfo.pattern.struct)
print "Screen Saver Executable: "+winstring(DTInfo.screenSaverExecutable.struct)
print "SettingID: "+winstring(DTInfo.settingID.struct)
print "Wallpaper: "+winstring(DTInfo.wallpaper.struct)
print ""
next
print ""
print ""


' Note: Not all PRODUCT fields fill in their information - They can leave (null)
print "********** PRODUCT Info **********"
print ""
rtn=GetISData()
print "#Products: ";str$(rtn)
print ""
for number=0 to rtn-1
rtn=GetISInfo(number)
print "Install State: "+str$(ISInfo.installState.struct)
print "Caption: "+winstring(ISInfo.caption.struct)
print "Description: "+winstring(ISInfo.description.struct)
print "Identifying Number: "+winstring(ISInfo.identifyingNumber.struct)
print "Install Date: "+winstring(ISInfo.installDate.struct)
print "Install Location: "+winstring(ISInfo.installLocation.struct)
print "Name: "+winstring(ISInfo.nname.struct)
print "Package Cache: "+winstring(ISInfo.packageCache.struct)
print "SKU Number: "+winstring(ISInfo.skuNumber.struct)
print "Vendor: "+winstring(ISInfo.vendor.struct)
print "Version: "+winstring(ISInfo.version.struct)
print ""
next
print ""
print ""


' Note: Not all PRODUCT fields fill in their information - They can leave (null)
print "********** SERVICE Info **********"
print ""
rtn=GetSSData()
print "#Services: ";str$(rtn)
print ""
for number=0 to rtn-1
rtn=GetSSInfo(number)
print "Accept Pause: "+str$(SSInfo.acceptPause.struct)
print "Accept Stop: "+str$(SSInfo.acceptStop.struct)
print "Desktop Interact: "+str$(SSInfo.desktopInteract.struct)
print "Process ID: "+str$(SSInfo.processID.struct)
print "Started: "+str$(SSInfo.started.struct)
print "Wait Hint: "+str$(SSInfo.waitHint.struct)
print "Caption: "+winstring(SSInfo.caption.struct)
print "Description: "+winstring(SSInfo.description.struct)
print "Display Name: "+winstring(SSInfo.displayName.struct)
print "Name: "+winstring(SSInfo.nname.struct)
print "Path Name: "+winstring(SSInfo.pathName.struct)
print "Service Type: "+winstring(SSInfo.serviceType.struct)
print "Start Mode: "+winstring(SSInfo.startMode.struct)
print "Start Name: "+winstring(SSInfo.startName.struct)
print "State: "+winstring(SSInfo.state.struct)
print "Status: "+winstring(SSInfo.status.struct)
print ""
next
print ""
print ""


' Note: Not all VIDEO fields fill in their information - They can leave (null)
print "********** VIDEO Info **********"
print ""
rtn=GetVIDEOData()
print "#Video Controllers: ";str$(rtn)
print ""
for number=0 to rtn-1
rtn=GetVIDEOInfo(number)
print "Adapter RAM: "+str$(VIDEOInfo.adapterRAM.struct)
print "Availability: "+str$(VIDEOInfo.availability.struct)
print "Color Table Entries: "+str$(VIDEOInfo.colorTableEntries.struct)
print "Current Bits-Per-Pixel: "+str$(VIDEOInfo.currentBitsPerPixel.struct)
print "Current Horizontal Resolution: "+str$(VIDEOInfo.currentHorizontalResolution.struct)
print "Current Number Of Columns: "+str$(VIDEOInfo.currentNumberOfColumns.struct)
print "Current Number Of Rows: "+str$(VIDEOInfo.currentNumberOfRows.struct)
print "Current Refresh Rate: "+str$(VIDEOInfo.currentRefreshRate.struct)
print "Current Scan Mode: "+str$(VIDEOInfo.currentScanMode.struct)
print "Current Vertical Resolution: "+str$(VIDEOInfo.currentVerticalResolution.struct)
print "Device Specific Pens: "+str$(VIDEOInfo.deviceSpecificPens.struct)
print "Dither Type: "+str$(VIDEOInfo.ditherType.struct)
print "ICM Intent: "+str$(VIDEOInfo.icmIntent.struct)
print "ICM Method: "+str$(VIDEOInfo.icmMethod.struct)
print "Maximum Memory Supported: "+str$(VIDEOInfo.maxMemorySupported.struct)
print "Maximum Number Controlled: "+str$(VIDEOInfo.maxNumberControlled.struct)
print "Maximum Refresh Rate: "+str$(VIDEOInfo.maxRefreshRate.struct)
print "Minimum Refresh Rate: "+str$(VIDEOInfo.minRefreshRate.struct)
print "Monochrome: "+str$(VIDEOInfo.monochrome.struct)
print "Number Of Color Planes: "+str$(VIDEOInfo.numberOfColorPlanes.struct)
print "Number Of Video Pages: "+str$(VIDEOInfo.numberOfVideoPages.struct)
print "Protocol Supported: "+str$(VIDEOInfo.protocolSupported.struct)
print "Reserved System Palette Entries: "+str$(VIDEOInfo.reservedSystemPaletteEntries.struct)
print "Specification Version: "+str$(VIDEOInfo.specificationVersion.struct)
print "Status Info: "+str$(VIDEOInfo.statusInfo.struct)
print "System Palette Entries: "+str$(VIDEOInfo.systemPaletteEntries.struct)
print "Video Architecture: "+str$(VIDEOInfo.videoArchitecture.struct)
print "Video Memory Type: "+str$(VIDEOInfo.videoMemoryType.struct)
print "Video Mode: "+str$(VIDEOInfo.videoMemoryType.struct)
print "Adapter Compatibility: "+winstring(VIDEOInfo.adapterCompatibility.struct)
print "Adapter DAC Type: "+winstring(VIDEOInfo.adapterDACType.struct)
print "Compatibility Descriptions: "+winstring(VIDEOInfo.compatibilityDescriptions.struct)
print "Caption: "+winstring(VIDEOInfo.caption.struct)
print "Description: "+winstring(VIDEOInfo.description.struct)
print "Device ID: "+winstring(VIDEOInfo.deviceID.struct)
print "Driver Version: "+winstring(VIDEOInfo.driverVersion.struct)
print "Inf Filename: "+winstring(VIDEOInfo.infFilename.struct)
print "Inf Section: "+winstring(VIDEOInfo.infSection.struct)
print "Installed Display Drivers: "+winstring(VIDEOInfo.installedDisplayDrivers.struct)
print "Name: "+winstring(VIDEOInfo.nname.struct)
print "PNP Device ID: "+winstring(VIDEOInfo.pnpDeviceID.struct)
print "Status: "+winstring(VIDEOInfo.status.struct)
print "Video Mode Description: "+winstring(VIDEOInfo.videoModeDescription.struct)
print "Video Processor: "+winstring(VIDEOInfo.videoProcessor.struct)
print ""
next
print ""
print ""


' Is this an Administrator using the computer?
rtn=IsAdministrator()
print "Administrator?: "+str$(rtn)

close #wmidll
end

function IsAdministrator()
calldll #wmidll,"Is_Admin",IsAdministrator as long
end function

function GetBIOSInfo()
calldll #wmidll,"Get_BIOSInfo",BIOSInfo as struct,GetBIOSInfo as Long
end function

function GetCPUInfo()
calldll #wmidll,"Get_CPUInfo",CPUInfo as struct,GetCPUInfo as Long
end function

function GetBUSData()
calldll #wmidll,"Get_BUSData",GetBUSData as Long
end function

function GetBUSInfo(index)
calldll #wmidll,"Get_BUSInfo",index as long,BUSInfo as struct,GetBUSInfo as Long
end function

function GetDTData()
calldll #wmidll,"Get_DTData",GetDTData as Long
end function

function GetDTInfo(index)
calldll #wmidll,"Get_DTInfo",index as long,DTInfo as struct,GetDTInfo as Long
end function

function GetHOTFIXESData()
calldll #wmidll,"Get_HOTFIXESData",GetHOTFIXESData as Long
end function

function GetHOTFIXESInfo(index)
calldll #wmidll,"Get_HOTFIXESInfo",index as long,HOTFIXESInfo as struct,GetHOTFIXESInfo as Long
end function

function GetISData()
calldll #wmidll,"Get_ISData",GetISData as Long
end function

function GetISInfo(index)
calldll #wmidll,"Get_ISInfo",index as long,ISInfo as struct,GetISInfo as Long
end function

function GetSSData()
calldll #wmidll,"Get_SSData",GetSSData as Long
end function

function GetSSInfo(index)
calldll #wmidll,"Get_SSInfo",index as long,SSInfo as struct,GetSSInfo as Long
end function

function GetNWAData()
calldll #wmidll,"Get_NWAData",GetNWAData as Long
end function

function GetNWAInfo(index)
calldll #wmidll,"Get_NWAInfo",index as long,NWAInfo as struct,GetNWAInfo as Long
end function

function GetOSInfo()
calldll #wmidll,"Get_OSInfo",OSInfo as struct,GetOSInfo as Long
end function

function GetUAData()
calldll #wmidll,"Get_UAData",GetUAData as Long
end function

function GetUAInfo(index)
calldll #wmidll,"Get_UAInfo",index as long,UAInfo as struct,GetUAInfo as Long
end function

function GetVIDEOData()
calldll #wmidll,"Get_VIDEOData",GetVIDEOData as Long
end function

function GetVIDEOInfo(index)
calldll #wmidll,"Get_VIDEOInfo",index as long,VIDEOInfo as struct,GetVIDEOInfo as Long
end function

